//加载页面
function InitPage() {
    loadingMsg.ShowLoadingMsg("数据加载中...");
    order.OrderDetails = null;
    order.OrderTenantID = "";
    GetOrderDetail(function(result) {
        var dataHeader = result.Data.Header;
        var dataDetail = result.Data.Details;
        
        dataDetail.sort(function(x,y){
            return x.ResNo - y.ResNo;
        });
        
        for(var i in dataDetail){
            if(parseFloat(dataDetail[i].PriceShowText) == 0 && dataHeader.PriceState != "CS90"){
                dataDetail[i].PriceShowText = "--";
            }
            if(parseFloat(dataDetail[i].OriginalPriceShowText) == 0){
                dataDetail[i].OriginalPriceShowText = "--";
            }
            if(dataHeader.PriceState != "CS90"){
                dataDetail[i].PriceShowText = dataDetail[i].OriginalPriceShowText;
            }
            if(dataDetail[parseInt(i)+1]){
                if(dataDetail[parseInt(i)+1].ResNo == dataDetail[parseInt(i)].ResNo){
                    dataDetail[parseInt(i)+1]["ShowFlag"] = "";
                    dataDetail[parseInt(i)]["ShowFlag"] = "uhide";
                }
            }
        }

        var tmpl = getHtmlContent("ResourceItem");
        var htmllist = zy_tmpl(tmpl, dataDetail);
        $("#resourceList").html(htmllist); 
        if($('.inputStyle').val() == ''){
            $('.inputStyle').val('0')
        }
        setFieldValue(result.Data);
        //判断买卖家
        var priceState = dataHeader.PriceState;
        var ownerRole = result.Data.OwnerRole;
        var statusDesc = "";
        if (ownerRole == "ONT01") {
            //卖家
            switch(priceState) {
            case "CS10":
                statusDesc = "买家提交了协议价格，等待您进行确认。";
                $("#resourceList [name=PriceRead]").removeClass("uhide");
                $("[name=btnPanelSeller]").removeClass("uhide");
                break;
            case "CS90":
                statusDesc = "价格已达成一致！";
                $(".msg").addClass("uhide");
                $(".msgok").removeClass("uhide");
                $(".delLine").removeClass("uhide");
                break;
            case "CS91":
                statusDesc = "买家的协议价格已经被您驳回，驳回原因：" + dataHeader.PriceResultDesc;
                break;
            default:
                break;
            }
        } else if (ownerRole == "ONT02") {
            //买家
            switch(priceState) {
            case "CS90":
                statusDesc = "价格已达成一致！";
                $(".msg").addClass("uhide");
                $(".msgok").removeClass("uhide");
                $(".delLine").removeClass("uhide");
                break;
            case "CS10":
            case "CS91":
                if (priceState == "CS10") {
                    statusDesc = "您的协议价格已经提交，请等待卖家同意您的协议价格。";
                } else {
                    statusDesc = "您的协议价格已经被卖家驳回，驳回原因：" + dataHeader.PriceResultDesc;
                }
                $("#resourceList [name=PriceRead]").addClass("uhide");
                $("#resourceList [name=PriceWrite]").removeClass("uhide");
                $("[name=btnPanelBuyer]").removeClass("uhide");
                break;
            default:
                break;
            }
        }
        $("[name=statusDesc]").html(statusDesc);
        loadingMsg.HideMsg();
    });
}

function GetOrderDetail(cb) {
    var CallData = {
        DID : OrderDetailID,
        DType : "D004",
        StrOptions : {
            "TenantID" : TenantID,
            "sTenantID" : TenantID
        }
    };
    callAjaxService("POST", "QueryDetail", CallData, true, function(result) {
        if (result && result.Data && result.ResultCode == "0") {
            order.OrderDetails = result.Data.Details;
            var dataHeader = result.Data.Header;
            if (dataHeader.BizTime && dataHeader.BizTime != "") {
                dataHeader.BizTime = dataHeader.BizTime.replace("T", " ").replace(/\..+/g, "");
                dataHeader.BizTime = dataHeader.BizTime.replace("00:00:00", "");
            }
            dataHeader.OrderMtrlQty = dataHeader.MtrlQty;
            order.OrderTenantID = dataHeader.TenantID;
            order.OwnerRole = result.Data.OwnerRole;
            FormatDataText(result);
            if (cb) {
                cb(result)
            }
        } else {
            noticeMsg = new SinochemPromptMsg("N", 3000);
            noticeMsg.ShowPromptMsg(result.ResultMsg);
        }
    }, function(result) {
        noticeMsg = new SinochemPromptMsg("N", 3000);
        noticeMsg.ShowPromptMsg(result.ResultMsg);
    });
}

function setFieldValue(data) {
    for (var key in data) {
        var value = data[key];
        $("[fieldName=" + key + "]").text(value);
    }
}

function FormatDataText(data) {
    for (var key in data) {
        if ( typeof (data[key]) == "object") {
            FormatDataText(data[key]);
        }

        //数量格式
        var quantityFilter = "|OrderMtrlQty|MtrlQty|";
        if (quantityFilter.indexOf("|" + key + "|") >= 0) {
            if ( typeof (data[key]) == "number") {
                data[key] = data[key].toFixed(3);
            }
        }

        if ( typeof (data[key]) == "number") {
            // data[key] = commafy(data[key].toFixed(2));
            data[key + "ShowText"] = commafy(data[key].toFixed(2));
        }

        if (!data[key] || data[key] == "") {
            switch(key) {
            case "ThumbnailURL":
                data[key] = "css/images/default.png";
                break;
            }
        } else {
            switch(key) {
            case "ResType":
                if (data[key] == "RT0201") {
                    data.ResTypeImage = "css/images/frowardGoods.png";
                } else {
                    data.ResTypeImage = "css/images/spotGoods.png";
                }
                break;
            }
        }
    }
}

var OrderOperate = {
    //价格验证
    ValidData : function() {
        var result = true;
        if (result) {
            $.each($("#resourceList input[name=BuyerPrice]"), function(index, obj) {
                if(!$(obj).hasClass("uhide")){
                    if ($(obj).attr("mustvalue") && $(obj).val() == "") {
                        warningMsg.ShowPromptMsg($(obj).attr("mustmsg"));
                        result = false;
                        return false;
                    } else if (!(/^[0-9]+.?[0-9]*$/).test($(obj).val())) {
                        warningMsg.ShowPromptMsg("价格只能输入数字，请更改！");
                        result = false;
                        return false;
                    } else if (($(obj).val().indexOf('"') >= 0 || $(obj).val().indexOf('\\') >= 0 || $(obj).val().indexOf('&') >= 0)) {
                        warningMsg.ShowPromptMsg("价格文本存在特殊字符，请更改！");
                        result = false;
                        return false;
                    } else if ($.trim($(obj).val()).length > $(obj).attr("maxlength")) {
                        warningMsg.ShowPromptMsg("价格文本超过规定长度啦！");
                        result = false;
                        return false;
                    } else if ((isNaN($(obj).val()) || parseFloat($(obj).val()) < parseFloat(0))) {
                        warningMsg.ShowPromptMsg("价格只能为数字并且不能小于0！");
                        result = false;
                        return false;
                    } else if ($(obj).val() != "" && !getRule("decimal2").test(parseFloat($(obj).val()))) {
                        warningMsg.ShowPromptMsg("价格只能保留2位小数！");
                        result = false;
                        return false;
                    }
                }
            });
        }
        return result;
    },
    //修改协议价格
    ChangeOrderPrice : function() {
        if (!OrderOperate.ValidData()) {
            return false;
        }
        new SinochemConfirmationMsg("", function() {

            var CallData = {
                StrOptions : {
                    "TenantID" : TenantID,
                    "OrderID" : OrderDetailID
                },
                sResList : OrderOperate.CollectResList()
            };
            callAjaxService("POST", "ChangeOrderPrice", CallData, true, function(result) {
                if (result && result.ResultCode == 0) {
                    successMsg.ShowPromptMsg("操作成功！");
                    setTimeout(function() {
                        ueppScript("OrderBudget","content","reloadData()");
                        ueppScript("OrderBudget", "content", "order.GetSaleOrderDetail()");
                        ueScript("OrderPriceConsult", "appcan.window.close(-1);");
                    }, 2000);
                } else {
                     showMessage(result.ResultMsg);
                }
            }, function(result) {
                noticeMsg.ShowPromptMsg(result.ResultMsg);
            });

        }, 2).ShowConfirmationMsg("", "确定修改协议价格吗？");

    },
    //不协商，按原价格下单
    NoNegotiationOrderPrice : function() {
        new SinochemConfirmationMsg("", function() {

            var CallData = {
                StrOptions : {
                    "TenantID" : TenantID,
                    "OrderID" : OrderDetailID
                }
            };
            callAjaxService("POST", "NoNegotiationOrderPrice", CallData, true, function(result) {
                if (result && result.ResultCode == 0) {
                    successMsg.ShowPromptMsg("操作成功！");
                    setTimeout(function() {
                        ueppScript("OrderBudget","content","reloadData()");
                        ueppScript("OrderBudget", "content", "order.GetSaleOrderDetail()");
                        ueScript("OrderPriceConsult", "appcan.window.close(-1);");
                    }, 2000);
                } else {
                    showMessage(result.ResultMsg);
                }
            }, function(result) {
                noticeMsg.ShowPromptMsg(result.ResultMsg);
            });

        }, 2).ShowConfirmationMsg("", "确定按原价格下单吗？");
    },
    //确认价格（同意或不同意）
    ConfirmOrderPrice : function(resultFlag) {
        var resultDesc = $.trim($("[name=Reason]").val());
        if (resultFlag == "N" && resultDesc == "") {
            warningMsg.ShowPromptMsg("若不同意，请您填写拒绝原因！");
            return false;
        }
        if (resultDesc.indexOf('"') >= 0 || resultDesc.indexOf('\\') >= 0) {
            warningMsg.ShowPromptMsg("文本存在特殊字符，请更改！");
            return false;
        }
        var resultmsg = "同意";
        if (resultFlag == "N") {
            resultmsg = "拒绝";
        }
        new SinochemConfirmationMsg("", function() {

            var CallData = {
                StrOptions : {
                    "TenantID" : TenantID,
                    "OrderID" : OrderDetailID,
                    "ResultFlag" : resultFlag,
                    "ResultDesc" : resultDesc
                }
            };
            callAjaxService("POST", "ConfirmOrderPrice", CallData, true, function(result) {
                if (result && result.ResultCode == 0) {
                    successMsg.ShowPromptMsg("操作成功！");
                    setTimeout(function() {
                        ueppScript("OrderBudget", "content", "order.GetSaleOrderDetail()");
                        ueScript("OrderPriceConsult", "appcan.window.close(-1);");
                    }, 2000);
                } else {
                    showMessage(result.ResultMsg);
                }
            }, function(result) {
                noticeMsg.ShowPromptMsg(result.ResultMsg);
            });

        }, 2).ShowConfirmationMsg("", "确定" + resultmsg + "并提交单据吗？");

    },
    //收集资源及价格信息
    CollectResList : function() {
        var json = {};
        var resJson = {};
        $.each($("div[name=ResList]"), function() {
            var lineID = $(this).attr("LineID"); 
            var ResNo = $(this).attr("ResNo"); 
            var picVal = $(this).find("input[name=BuyerPrice]").val();
            json[lineID] = ResNo;
            resJson[ResNo] = picVal;
        });
        for(var i in json){
            for(var z in resJson){
                if(json[i] == z){
                    json[i] = resJson[z];
                }
            }
        }
        return json;
    }
}

function getRule(key) {
    var map = {
        //正整数
        intnum : /^\d*$/,
        //小数，保留三位小数(正数)
        decimal3 : /^[0-9]{1,}[.][0-9]{0,3}$|^[1-9][0-9]{0,}[.][0-9]{0,3}$|^[1-9][0-9]*$|^0$/,
        //小数,保留2位小数
        decimal2 : /^\d+(\.(\d?[1-9]$))?$/
    };

    if (map[key] && map[key] != "")
        return map[key];
    else
        return "";
}