(function(w) {
    w.NoticeOperation = function(params) {
        this.TenantID = "";
        this.CreatedBy = "";
        this.OwnerRole = "ONT02";
        this.NoticeID = "";
        this.DType = "D009";
        this.CallBack = function(result) {
        };
        this.NoticeMsg = new SinochemPromptMsg("N", 3000);
        for (var key in params) {
            this[key] = params[key];
        }
    }
    $.extend(NoticeOperation.prototype, {
        NoticeCall : function(CallData, functionName, needCallBack, extraFun, errFun) {
            var thisObj = this;
            callAjaxService("POST", functionName, CallData, true, function(result) {
                if (result.ResultCode == "0") {
                    if (extraFun) {
                        extraFun(result);
                    }
                    if (needCallBack) {
                        thisObj.CallBack(result);
                    }
                } else {
                    thisObj.NoticeMsg.ShowPromptMsg(result.ResultMsg);
                    if (errFun) {
                        errFun();
                    }
                }
            }, function(result) {
                if (errFun) {
                    errFun();
                }
            });
        },
        SaveNotice : function(params, cb, err) {
            var CallData = {
                StrOptions : {},
                TenantID : this.TenantID,
                OwnerRole : this.OwnerRole,
                CreatedBy : this.CreatedBy,
                Memo : ""
            };
            for (var key in params) {
                CallData[key] = params[key];
            }

            this.NoticeCall(CallData, "SaveSRNotice", false, function(result) {
                if (cb) {
                    cb(result);
                }
            }, function(result) {
                if (err) {
                    err(result);
                }
            });
        },
        SubmitNotice : function(cb, err) {
            var CallData = {
                StrOptions : {},
                TenantID : this.TenantID,
                NoticeID : this.NoticeID
            };

            this.NoticeCall(CallData, "SubmitSRNotice", false, function(result) {
                if (cb) {
                    cb(result);
                }
            }, function(result) {
                if (err) {
                    err(result);
                }
            });
        },
        GetNoticeInfo : function() {
            var CallData = {
                DType : this.DType,
                StrOptions : {
                    TenantID : this.TenantID,
                    NoticeID : this.NoticeID
                }
            }
            this.NoticeCall(CallData, "QueryDetail", true, function(result) {
                formatData(result);
                var dataHeader = result.Data.Header;
                if (!dataHeader.CurrencyCode) {
                    dataHeader.CurrencyCode = "";
                }
                switch(dataHeader.TransMode) {
                case "TM01":
                    dataHeader.TransModeName = "物流";
                    break;
                case "TM02":
                    dataHeader.TransModeName = "上门退货";
                    break;
                }
            });
        },
        DeleteNotice : function(cb) {
            var CallData = {
                DType : this.DType,
                StrOptions : {
                    TenantID : this.TenantID,
                    NoticeID : this.NoticeID
                }
            }
            this.NoticeCall(CallData, "DeleteSRNoticeByID", false, function(result) {
                if (cb) {
                    cb(result);
                }
            });
        },
        CancelNotice : function(cb) {
            var CallData = {
                DType : this.DType,
                StrOptions : {
                    TenantID : this.TenantID,
                    NoticeID : this.NoticeID
                }
            }
            this.NoticeCall(CallData, "RecallSRNotice", false, function(result) {
                if (cb) {
                    cb(result);
                }
            });
        }
    });

    function formatData(obj) {
        for (var key in obj) {
            if ( typeof (obj[key]) == "object") {
                formatData(obj[key])
            }

            if (key.indexOf("Time") >= 0 || key == "CreatedAt") {
                if (obj[key]) {
                    obj[key] = obj[key].split('T')[0];
                }
            }

            if (key.indexOf("Amount") >= 0) {
                obj[key] = parseFloat(obj[key]).toFixed(2);
            }
            if (key.indexOf("Qty") >= 0) {
                obj[key] = parseFloat(obj[key]).toFixed(3);
            }
            switch(key) {

            default:
                break;
            }
        }
    }

})(window)
