(function(window) {
    window.PartenerTally = function(params) {
        this.StrOptions = null;
        this.PeriodList = {
            Text : ["一年之内", "六个月内", "三个月内", "一个月内"],
            Value : [12, 6, 3, 1]
        }
        this.OrderType = {
            Text : ["采购订单", "销售订单"],
            Code : ["PO", "SO"]
        }
        this.OrderTitle = {
            PO : "采购订单",
            SO : "销售订单"
        }
        this.CallBack = function(result) {
        }
        for (var key in params) {
            this[key] = params[key];
        }
    }
    $.extend(PartenerTally.prototype, {
        TallyCall : function(CallData, functionName, extraFun) {
            noticeMsg = new SinochemPromptMsg("N", 3000);
            var tallyObj = this;
            callAjaxService("POST", functionName, CallData, true, function(result) {
                if (result.ResultCode == "0") {
                    if (result.Data && result.Data.Items && result.Data.Items == null) {
                        result.Data.Items = [];
                    }
                    if (extraFun) {
                        extraFun(result);
                    }
                    tallyObj.CallBack(result);
                } else {
                    noticeMsg.ShowPromptMsg(result.ResultMsg);
                }
            }, function(result) {
                noticeMsg.ShowPromptMsg("获取失败,请稍后重试！");
            });
        }
    });

    window.PartenerTallyInfo = function(params) {
        PartenerTally.call(this, {});
        this.PartnerID = "";
        this.TenantID = "";
        for (var key in params) {
            this[key] = params[key];
        }
    }
    PartenerTallyInfo.prototype = new PartenerTally();
    $.extend(PartenerTallyInfo.prototype, {
        GetTallyInfo : function(requirements, type) {
            noticeMsg = new SinochemPromptMsg("N", 3000);
            if (this.PartnerID == "") {
                noticeMsg.ShowPromptMsg("参数PartnerID必传");
            }
            if (this.TenantID == "") {
                noticeMsg.ShowPromptMsg("参数TenantID必传");
            }
            if (requirements.StartTime == "") {
                noticeMsg.ShowPromptMsg("参数StartTime必传");
            }
            if (requirements.EndTime == "") {
                noticeMsg.ShowPromptMsg("参数EndTime必传");
            }
            if (this.StrOptions == null) {
                noticeMsg.ShowPromptMsg("参数StrOptions必传");
            }
            var CallData = {
                PartnerID : this.PartnerID,
                StrOptions : this.StrOptions,
                TenantID : this.TenantID,
                StartTime : requirements.StartTime,
                EndTime : requirements.EndTime
            };
            this.TallyCall(CallData, "GetPartnerTallyKPI", function(result) {
                var ptData = result.Data.Table[0];
                result.Order_Count = ptData[type + "_ORDER_Count"] || 0
                if (ptData[type + "_ORDER_LastBizTime"]) {
                    ptData[type + "_ORDER_LastBizTime"] = ptData[type + "_ORDER_LastBizTime"].replace("T", " ").replace(/\..*/g, "");
                    result.ORDER_LastBizTime = ptData[type + "_ORDER_LastBizTime"];
                }

                result.ptAmountData = new Array();
                for (var i in result.Data.Table1) {
                    amountItem = result.Data.Table1[i];
                    amountItem.Amount = amountItem.Amount == 0 ? "0.00" : commafy(amountItem.Amount.toFixed(2));
                    if (amountItem.OrderType == type) {
                        result.ptAmountData.push(amountItem);
                    }
                }
            });
        }
    });

    window.PartenerTallyOrderList = function(params) {
        PartenerTally.call(this, {});
        this.LType = "L016";
        for (var key in params) {
            this[key] = params[key];
        }
    }
    PartenerTallyOrderList.prototype = new PartenerTally();
    $.extend(PartenerTallyOrderList.prototype, {
        GetTallyOrderList : function(type) {
            if (this.StrOptions == null) {
                noticeMsg = new SinochemPromptMsg("N", 3000);
                noticeMsg.ShowPromptMsg("参数StrOptions必传");
            }
            this.StrOptions.PageIndex = 1;
            this.StrOptions.PageSize = 9999;
            this.StrOptions.queryType = "QT0701";

            var CallData = {
                LType : this.LType,
                StrOptions : this.StrOptions
            };
            var ptObj = this;
            this.TallyCall(CallData, "QueryList", function(result) {
                var orderList = new Array();
                for (var i in result.Data.Items) {
                    var order = result.Data.Items[i];
                    order.OrderTitle = ptObj.OrderTitle[type];
                    order.OrderAmount = commafy(order.OrderAmount.toFixed(2));
                    switch(type) {
                    case "SO":
                        //销售订单
                        if (order.OwnerRole != "ONT02") {
                            orderList.push(order);
                        }
                        break;
                    case "PO":
                        //采购订单
                        if (order.OwnerRole == "ONT02") {
                            orderList.push(order);
                        }
                        break;
                    default:
                        break;
                    }

                    var list = result.Data.Items;
                    var materiels = new Array();
                    for (var j in list[i].Details) {
                        materiels.push(list[i].Details[j].MaterialName);
                    }
                    list[i].MaterialName = materiels.join(",");
                }

                result.Data.Items = orderList;
            });
        }
    });

})(window)
