(function(window) {
    window.TradingResource = function(params) {
        this.StrOptions = null;
        this.DType = "D002";
        //this.ResID = "";
        this.LogisticsTypeList = null;
        this.EnterpriseList = new Array();
        //this.ResLineID = "";
        this.ResourceList = new Array();
        this.ResourceIDList = new Array();
        this.CallBack = function() {
        };
        for (var key in params) {
            this[key] = params[key];
        }
    }
    $.extend(TradingResource.prototype, {
        TradingCall : function(CallData, functionName, needCallBack, extraFun, errorFun) {
            noticeMsg = new SinochemPromptMsg("N", 3000);
            var thisObj = this;
            callAjaxService("POST", functionName, CallData, true, function(result) {
                if (result.ResultCode == "0") {
                    if (result.Data && result.Data.Items && result.Data.Items == null) {
                        result.Data.Items = [];
                    }
                    // if ( typeof (result.Data) == "string") {
                    // result.Data = JSON.parse(result.Data);
                    // }

                    if (extraFun) {
                        extraFun(thisObj, result);
                    }
                    if (needCallBack) {
                        thisObj.CallBack(result);
                    }
                } else {
                    noticeMsg.ShowPromptMsg(result.ResultMsg);
                    if (errorFun) {
                        errorFun();
                    }
                }
            }, function(result) {
                noticeMsg.ShowPromptMsg(loadFailMsg);
                if (errorFun) {
                    errorFun();
                }
            });
        },
        GetResource : function(resID, resNum, extraFun) {
            if (!resID || resID == "") {
                noticeMsg = new SinochemPromptMsg("N", 3000);
                noticeMsg.ShowPromptMsg("参数ResID必传");
                return;
            }
            var CallData = {
                DType : this.DType,
                DID : resID,
                StrOptions : {}
            };

            this.TradingCall(CallData, "QueryDetail", false, function(thisObj, result) {
                var data = result.Data.Details[0];
                for (var i in thisObj.ResourceIDList) {
                    if (data.ResID == thisObj.ResourceIDList[i].resID) {
                        result.Data.Header.InNumber = resNum;
                        result.index = i;
                        thisObj.ResourceList.push(result);
                        break;
                    }
                }
                if (extraFun) {
                    extraFun(thisObj);
                }
            });
        },
        GetResourceList : function(resIDs) {
            for (var i in resIDs) {
                this.ResourceIDList.push({
                    resID : resIDs[i].ResID
                });
                this.GetResource(resIDs[i].ResID, resIDs[i].Number, function(thisObj) {
                    if (resIDs.length == thisObj.ResourceList.length) {
                        thisObj.ResourceList.sort(function(a, b) {
                            return a.index - b.index;
                        });
                        thisObj.CallBack();
                    }
                });
            }
        },
        GetLogisticsTypeList : function(cb) {
            var CallData = {
                LType : "L018",
                StrOptions : {
                    ctcode : "EBS.LogiMode"
                }
            };
            this.TradingCall(CallData, "QueryList", false, function(thisObj, result) {
                thisObj.LogisticsTypeList = result.Data;
                if (cb) {
                    cb(thisObj.LogisticsTypeList);
                }
            });
        },
        GetEnterpriseList : function(cb, partnerTenantID, resID) {
            var CallData = {
                LType : "L022",
                StrOptions : {}
            };
            if (partnerTenantID && partnerTenantID != "") {
                CallData.LType = "L025";
                CallData.StrOptions.ResID = resID;
            }
            this.TradingCall(CallData, "QueryList", false, function(thisObj, result) {
                var list = result.Data;

                if (partnerTenantID && partnerTenantID != "") {
                    var tempItem = null;
                    for (var i in list)
                    if (list[i].TenantID == partnerTenantID) {
                        tempItem = list[i];
                        list.splice(i, 1);
                        break;
                    }
                    if (tempItem != null) {
                        list.splice(0, 0, tempItem);
                    }
                }

                thisObj.EnterpriseList.push(list);
                if (cb) {
                    cb(thisObj);
                }
            });
        },
        GetAllEnterpriseList : function(cb, partnerTenantID, resIDs) {
            for (var i in resIDs) {
                this.GetEnterpriseList(function(thisObj) {
                    if (resIDs.length == thisObj.EnterpriseList.length) {
                        var resultList = thisObj.EnterpriseList[0];
                        for (var j = 1; j < thisObj.EnterpriseList.length; j++) {
                            resultList = getIntersection(resultList, thisObj.EnterpriseList[j]);
                        }
                        thisObj.EnterpriseList = resultList;
                        if (cb) {
                            cb(resultList);
                        }
                    }
                }, partnerTenantID, resIDs[i].ResID);
            }
        },
        //废弃
        // SubmitOrder : function(sWLFlag, quantity, requirements, cb, errorCb) {
        // noticeMsg = new SinochemPromptMsg("N", 3000);
        // if (!sWLFlag || sWLFlag == "") {
        // noticeMsg.ShowPromptMsg("参数sWLFlag必传");
        // return;
        // }
        // if (!quantity || quantity == "" || quantity == 0) {
        // noticeMsg.ShowPromptMsg("参数quantity必传");
        // return;
        // }
        // var CallData = {
        // orderType : "OT01",
        // sWLFlag : sWLFlag,
        // dQuantity : quantity,
        // sResID : this.ResID,
        // sResLineID : this.ResLineID,
        // StrOptions : {},
        // };
        // for (var key in requirements) {
        // CallData.StrOptions[key] = requirements[key];
        // }
        // this.TradingCall(CallData, "CreateOrder", false, function(thisObj, result) {
        // if (cb) {
        // cb(result);
        // }
        // }, errorCb);
        // }
        //tenantID：选择的企业ID，rootTenantID：用户的ID
        BalanceCartGoods : function(requerments, opMode, tenantID, rootTenantID, cb, errorCb) {
            var CallData = {
                orderType : "OT02", //OT01(销售单据) OT02(采购单据) OT03(物流单据)
                StrOptions : {}
            };
            noticeMsg = new SinochemPromptMsg("N", 3000);
            if (!tenantID || tenantID == "") {
                noticeMsg.ShowPromptMsg("参数TenantID必传");
                return;
            }
            if (!rootTenantID || rootTenantID == "") {
                noticeMsg.ShowPromptMsg("参数RootTenantID必传");
                return;
            }
            //0一键下单，1购物车下单
            if (!opMode || opMode == "") {
                noticeMsg.ShowPromptMsg("参数OPMode必传");
                return;
            }
            CallData.StrOptions.TenantID = tenantID;
            CallData.StrOptions.RootTenantID = rootTenantID;
            CallData.StrOptions.OPMode = opMode;

            if (!requerments["BuyerID"] || requerments["BuyerID"] == "") {
                noticeMsg.ShowPromptMsg("参数BuyerID必传");
                return;
            }
            if (!requerments["BuyerName"] || requerments["BuyerName"] == "") {
                noticeMsg.ShowPromptMsg("参数BuyerName必传");
                return;
            }
            if (!requerments["sResList"] || requerments["sResList"] == "") {
                noticeMsg.ShowPromptMsg("参数sResList必传");
                return;
            }
            for (var key in requerments) {
                CallData[key] = requerments[key];
            }

            this.TradingCall(CallData, "BalanceCartGoods", false, function(thisObj, result) {
                if (cb) {
                    cb(result);
                }
            }, errorCb);
        },
        GetBalanceResult : function(balanceID, cb, errorCb) {
            var CallData = {
                StrOptions : {},
            };
            noticeMsg = new SinochemPromptMsg("N", 3000);
            if (!balanceID || balanceID == "") {
                noticeMsg.ShowPromptMsg("参数BalanceID必传");
                return;
            }

            CallData.StrOptions.BalanceID = balanceID;
            this.TradingCall(CallData, "GetBalanceResult", false, function(thisObj, result) {
                if (cb) {
                    cb(result);
                }
            }, errorCb);
        },
        GetBalanceResultList : function(tenantID, balanceID, cb, errorCb) {
            var CallData = {
                LType : "L016",
                StrOptions : {
                    queryType : "QT0735",
                    State : ""
                }
            };
            if (!tenantID || tenantID == "") {
                noticeMsg.ShowPromptMsg("参数TenantID必传");
                return;
            }
            if (!balanceID || balanceID == "") {
                noticeMsg.ShowPromptMsg("参数BalanceID必传");
                return;
            }
            CallData.StrOptions.TenantID = tenantID;
            CallData.StrOptions.BalanceID = balanceID;
            this.TradingCall(CallData, "QueryList", false, function(thisObj, result) {
                for (var i in result.Data.Items) {
                    var details = result.Data.Items[i].Details;
                    for (var j in details) {
                        details[j].MtrlQty = details[j].MtrlQty.toFixed(2);
                        details[j].ThumbnailURL = (details[j].ThumbnailURL && details[j].ThumbnailURL != "" ? details[j].ThumbnailURL : "css/images/default.png");
                    }
                }
                if (cb) {
                    cb(result);
                }
            }, errorCb);
        }
    });

    function getIntersection(arrA, arrB) {
        var resultList = Array();
        for (var i in arrA) {
            for (var j in arrB) {
                if (arrA[i].TenantID == arrB[j].TenantID) {
                    resultList.push(arrA[i]);
                    break;
                }
            }
        }
        return resultList
    }

})(window)
