var OAConfig = strToJson(getLocVal("OAConfig"));
var xgldFieldName = "xgld";

/*根据流程编码获取配置信息（表单新建时使用）*/
function GetConfigModelByWorkFlowCode(code) {
    for (var i = 0; i < OAConfig.length; i++) {
        var ConfigModel = OAConfig[i];
        var WorkflowCode = ConfigModel.OAWorkflow[0].WorkflowCode;
        if (code == WorkflowCode) {
            return ConfigModel;
        }
    }
    return {};
}

function loadConfig(workflowCode, fn, pageName, target) {
    var callData = {
        usercode : getLocVal('usercode') || "wangwen05",
        appID : appID
    };
    callData.WorkflowID = 0;
    callData.VersionID = GetConfigModelByWorkFlowId(0).OAWFVersion ? GetConfigModelByWorkFlowId(0).OAWFVersion[0].VersionCode : 0;
    callAjaxService("GET", "GetWFAttriByWFID", callData, true, function(info) {
        if (info.Data[0].OAWFVersion[0].VersionCode && callData.VersionID < info.Data[0].OAWFVersion[0].VersionCode) {
            SetConfigModelByWorkFlowId(info.Data[0].OAWorkflow[0].WorkflowID, info.Data[0]);
        }
        callData.WorkflowID = workflowCode;
        callData.VersionID = GetConfigModelByWorkFlowCode(workflowCode).OAWFVersion ? GetConfigModelByWorkFlowCode(workflowCode).OAWFVersion[0].VersionCode : 0;
        callAjaxService("GET", "GetWFAttriByWFID", callData, true, function(info) {
            if (info.Data[0].OAWFVersion[0].VersionCode && callData.VersionID < info.Data[0].OAWFVersion[0].VersionCode) {
                SetConfigModelByWorkFlowId(info.Data[0].OAWorkflow[0].WorkflowID, info.Data[0]);
            }
            if (fn) {
                fn(workflowCode, pageName, target)
            }
        });
    });
}

/*处理workflowMainTableInfo里的WorkflowRequestTableField，
 * 根据配置将返回字段增加是否在移动端显示的自定义属性
 * */
/*申请单填写页面使用，处理某些字段是否显示，以及哪些字段是隐藏起来的（新建表单信息时使用）*/
function DealBaseData(data) {
    var workflowid = data.data.workflowBaseInfo.workflowId;
    var nodeid = data.data.currentNodeId;
    var ConfigModelTableField = GetConfigModelTableField(workflowid, nodeid);
    var object = data.data.workflowMainTableInfo.requestRecords.WorkflowRequestTableRecord[0].workflowRequestTableFields;
    DealTableFieldSort(ConfigModelTableField, object.WorkflowRequestTableField);
    for (var j in object.WorkflowRequestTableField) {
        var obj = object.WorkflowRequestTableField[j];
        var t = 0;
        var p = 0;
        var r = 0;
        var s = 0;
        for (var m in ConfigModelTableField) {
            var Localobj = ConfigModelTableField[m];
            if (obj.fieldName == Localobj.FieldCode) {
                if (Localobj.IsAddShow == "Y") {
                    t++;
                }
                if (Localobj.IsHidden == "Y") {
                    p++;
                }
                if (Localobj.IsReadonly == "Y") {
                    r++;
                }
                if (Localobj.IsHidden == "S") {
                    s++;
                }
                break;
            }
        }
        if (t <= 0) {
            obj["IsShow"] = false;
        } else {
            obj["IsShow"] = true;
        }
        if (p <= 0) {
            obj["IsDivHidden"] = false;
        } else {
            obj["IsDivHidden"] = true;
        }
        if (p <= 0) {
            obj["IsReadonly"] = false;
        } else {
            obj["IsReadonly"] = true;
        }
        if (s <= 0) {
            obj["isMyshow"] = false;
        } else {
            obj["isMyshow"] = true;
        }
    }
}

/*根据流程id获取配置信息*/
function GetConfigModelByWorkFlowId(Id) {
    for (var i = 0; i < OAConfig.length; i++) {
        var ConfigModel = OAConfig[i];
        var workflowId = ConfigModel.OAWorkflow[0].WorkflowID;
        var activeFlag = ConfigModel.OAWorkflow[0].ActiveFlag;
        if (Id == workflowId && activeFlag == "Y") {
            return ConfigModel;
        }
    }
    return {};
}

/*根据流程id设置配置信息*/
function SetConfigModelByWorkFlowId(Id, info) {
    var flag = false;
    for (var i = 0; i < OAConfig.length; i++) {
        var ConfigModel = OAConfig[i];
        var workflowId = ConfigModel.OAWorkflow[0].WorkflowID;
        var activeFlag = ConfigModel.OAWorkflow[0].ActiveFlag;
        if (Id == workflowId) {
            OAConfig[i] = info;
            flag = true;
            break;
        }
    }
    if (!flag) {
        if (!OAConfig.length) {
            OAConfig = new Array();
        }
        OAConfig.push(info);
    }
    setLocVal("OAConfig", JSON.stringify(OAConfig));
}

/*判断是否包含正文*/
function GetHavezhengwen(Id) {
    var ConfigModel = GetConfigModelByWorkFlowId(Id);
    if (ConfigModel.OAWorkflow) {
        if (ConfigModel.OAWorkflow[0].HasBody == "Y") {
            return true;
        }
    }
    return false;
}

/*绑定字段值的过滤*/
function BindFieldFilter(workflowid) {
    var ConfigModel = GetConfigModelByWorkFlowId(workflowid);
    if (ConfigModel.OAWFAttriFilter && ConfigModel.OAWFAttriFilter.length > 0) {
        for (var i in ConfigModel.OAWFAttriFilter) {
            var FiledCode = ConfigModel.OAWFAttriFilter[i].FieldCode;
            var FilterType = ConfigModel.OAWFAttriFilter[i].FilterType;
            var IsFixedFilter = ConfigModel.OAWFAttriFilter[i].IsFixedFilter;
            var RefFieldCode = ConfigModel.OAWFAttriFilter[i].RefFieldCode;
            var leadersText = $('[filedname="' + FiledCode + '"]');
            if (leadersText.length > 0) {
                leadersText.bind("DOMNodeInserted", function() {
                    DealDataDistinct(FiledCode, RefFieldCode, FilterType, IsFixedFilter);
                });
            }
        }

    }
}

/*控制字段值的过滤*/
function DealDataDistinct(FiledCode, RefFieldCode, FilterType, IsFixedFilter) {
    var filedvalue = strToJson(getLocVal(FiledCode + "_Items"));
    var controlvalue = $('[filedname="' + RefFieldCode + '"]').attr("FieldValue").split(",");
    if (IsFixedFilter == 'N' && FilterType == "not in") {
        for (var i in filedvalue) {
            for (var j in controlvalue) {
                if (filedvalue[i].itemID == controlvalue[j]) {
                    filedvalue.splice(i, 1);
                }
            }
        }

        setLocVal(FiledCode + "_Items", jsonToStr(filedvalue));
        var ihtml = GetOrgnizationShowHtml(FiledCode, filedvalue);
        $('[filedname="' + FiledCode + '"]').html(ihtml);
    }
}

/*获取工作流的字段相关配置信息*/
function GetConfigModelTableField(Id, NodeID) {
    var ConfigModel = GetConfigModelByWorkFlowId(Id);
    var ConfigModelCommon = GetConfigModelByWorkFlowId(0);
    var ConfigOAWFAttri = [];
    for (var i = 0; i < ConfigModelCommon.OAWFAttri.length; i++) {
        for (var j in ConfigModelCommon.OAWFAttri[i]) {
            ConfigOAWFAttri.push(ConfigModelCommon.OAWFAttri[i][j]);
        }
    }
    var m = 0;
    if (ConfigModel.OAWFAttri) {
        for (var i = 0; i < ConfigModel.OAWFAttri.length; i++) {
            if (ConfigModel.OAWFAttri[i][0].NodeCode == NodeID) {
                for (var j in ConfigModel.OAWFAttri[i]) {
                    if (ConfigModel.OAWFAttri[i][j].AttriArea == "Node") {
                        ConfigOAWFAttri.push(ConfigModel.OAWFAttri[i][j]);
                    }
                }
                m++;
                break;
            }
        }
        NodeID = 0;
        for (var i = 0; i < ConfigModel.OAWFAttri.length; i++) {
            if (ConfigModel.OAWFAttri[i][0].NodeCode == NodeID) {
                for (var j in ConfigModel.OAWFAttri[i]) {
                    if (ConfigModel.OAWFAttri[i][j].AttriArea == "Node") {
                        ConfigOAWFAttri.push(ConfigModel.OAWFAttri[i][j]);
                    }
                }
                break;
            }
        }
    }
    return ConfigOAWFAttri;
}

/*获取工作流的字段相关配置明细行的信息*/
function GetConfigModelTableDetailField(Id, NodeID) {
    var ConfigModel = GetConfigModelByWorkFlowId(Id);
    var ConfigOAWFAttri = [];
    if (ConfigModel.OAWFAttri) {
        for (var i = 0; i < ConfigModel.OAWFAttri.length; i++) {
            if (ConfigModel.OAWFAttri[i][0].NodeCode == NodeID) {
                for (var j in ConfigModel.OAWFAttri[i]) {
                    if (ConfigModel.OAWFAttri[i][j].AttriArea == "DetailList") {
                        ConfigOAWFAttri.push(ConfigModel.OAWFAttri[i][j]);
                    }
                }
                break;
            }
        }
        NodeID = 0;
        for (var i = 0; i < ConfigModel.OAWFAttri.length; i++) {
            if (ConfigModel.OAWFAttri[i][0].NodeCode == NodeID) {
                for (var j in ConfigModel.OAWFAttri[i]) {
                    if (ConfigModel.OAWFAttri[i][j].AttriArea == "DetailList") {
                        ConfigOAWFAttri.push(ConfigModel.OAWFAttri[i][j]);
                    }
                }
                break;
            }
        }
    }
    return ConfigOAWFAttri;
}

/*将泛微返回的属性列表按照后台配置进行重新排序*/
function DealTableFieldSort(ConfigModelTableField, WorkflowRequestTableField) {
    ConfigModelTableField.sort(function(a, b) {
        return parseInt(a.Weight) - parseInt(b.Weight);
    });
    for (var j in WorkflowRequestTableField) {
        var obj = WorkflowRequestTableField[j];
        obj["LocSort"] = parseInt(WorkflowRequestTableField.length + 1);
        obj["Sort"] = j;
        for (var m in ConfigModelTableField) {
            var Localobj = ConfigModelTableField[m];
            if (obj.fieldName == Localobj.FieldCode) {
                obj["LocSort"] = Localobj.Weight;
                break;
            }
        }
    }
    WorkflowRequestTableField.sort(function(a, b) {
        if (a.LocSort != b.LocSort) {
            return parseInt(a.LocSort) - parseInt(b.LocSort);
        } else {
            return parseInt(a.Sort) - parseInt(b.Sort);
        }
    });
    DealTableFieldAdd(ConfigModelTableField, WorkflowRequestTableField);
}

/*处理表单字段是否为自定义属性。将自定义属性的集合存储起来*/
function DealTableFieldAdd(ConfigModelTableField, WorkflowRequestTableField) {
    var addFieldarray = [];
    for (var m in ConfigModelTableField) {
        var Localobj = ConfigModelTableField[m];
        var num = 0;
        for (var j in WorkflowRequestTableField) {
            var obj = WorkflowRequestTableField[j];
            if (obj.fieldName == Localobj.FieldCode) {
                num++;
                break;
            }
        }
        if (num <= 0 && Localobj.IsBaseInfo == "C") {
            addFieldarray.push(Localobj);
        }
    }
    setLocVal("addFieldarray", jsonToStr(addFieldarray));
}

/*提交时校验相关字段的关联性*/
function CheckTableControl(workflowid, NodeId) {
    var ConfigModel = GetConfigModelByWorkFlowId(workflowid);
    if (ConfigModel.OAWFAttriCondition.length > 0) {
        for (var i in ConfigModel.OAWFAttriCondition) {
            var controldata = ConfigModel.OAWFAttriCondition[i];
            if (controldata.NodeCode != 0 && controldata.NodeCode != NodeId) {
                continue;
            }
            var fieldKey = controldata.FieldCode;
            var fieldName = controldata.FieldName;
            var fieldType = controldata.FieldType;
            var fieldValue = controldata.FieldValue;
            var fieldcontrol = controldata.RefFieldCode;
            var fieldcontrolName = controldata.RefFieldName;
            var fieldcontrolType = controldata.RefType;
            var fieldcontrolValue = controldata.RefValue;

            if ($("[filedname='" + fieldKey + "']").length > 0 && $("[filedname='" + fieldcontrol + "']").length > 0) {
                switch(fieldType) {
                case "Select":
                    /*fieldKey==fieldcontrol表示fieldKey字段为必填项*/
                    if (fieldKey == fieldcontrol) {
                        var selelindex = $("[filedname='"+fieldKey+"']")[0].selectedIndex;
                        var seleltext = $("[filedname='"+fieldKey+"']")[0].options[selelindex].text;
                        var selelvalue = $("[filedname='"+fieldKey+"']")[0].options[selelindex].value;
                        if (selelvalue == "") {
                            var noticeMsg = new SinochemPromptMsg("W", 3000);
                            noticeMsg.ShowPromptMsg("请选择" + fieldName);
                            return false;
                        }
                    }
                    var selelindex = $("[filedname='"+fieldKey+"']")[0].selectedIndex;
                    if (selelindex != undefined) {
                        var seleltext = $("[filedname='"+fieldKey+"']")[0].options[selelindex].text;
                        var selelvalue = $("[filedname='"+fieldKey+"']")[0].options[selelindex].value;
                        if (selelvalue == fieldValue) {
                            switch(fieldcontrolType) {
                            case "Div":
                                var textval = getLocVal(fieldcontrol + "_Items");
                                if (fieldcontrolValue == "非空") {
                                    if (textval == "[]") {
                                        var noticeMsg = new SinochemPromptMsg("W", 3000);
                                        noticeMsg.ShowPromptMsg(fieldName + "值为'" + seleltext + "'时" + fieldcontrolName + "必须选择");
                                        return false;
                                    }
                                }
                                break;
                            case "Select":
                                if (fieldcontrolValue == "非空") {
                                    var selelindex = $("[filedname='"+fieldcontrol+"']")[0].selectedIndex;
                                    var textval = $("[filedname='"+fieldcontrol+"']")[0].options[selelindex].value;
                                    if (textval == "") {
                                        var noticeMsg = new SinochemPromptMsg("W", 3000);
                                        noticeMsg.ShowPromptMsg(fieldName + "值为'" + seleltext + "'时" + fieldcontrolName + "必须选择");
                                        return false;
                                    }
                                } else {
                                    var fieldcontrolValueArry = fieldcontrolValue.split(',');
                                    var selelindex2 = $("[filedname='"+fieldcontrol+"']")[0].selectedIndex;
                                    if (selelindex2 != undefined) {
                                        var seleltext2 = $("[filedname='"+fieldcontrol+"']")[0].options[selelindex2].text;
                                        var selelvalue2 = $("[filedname='"+fieldcontrol+"']")[0].options[selelindex2].value;
                                        if (fieldcontrolValueArry.indexOf(selelvalue2) < 0 && selelvalue2 != "" && selelvalue2 != undefined) {
                                            var name = "";
                                            var selectarry = $("[filedname='"+fieldcontrol+"']")[0].options;
                                            for (var m in selectarry) {
                                                for (var t in fieldcontrolValueArry) {
                                                    if (selectarry[m].value == fieldcontrolValueArry[t]) {
                                                        name += selectarry[m].text + ",";
                                                    }
                                                }
                                            }
                                            name = name.substring(0, name.length - 1);
                                            var noticeMsg = new SinochemPromptMsg("W", 3000);
                                            noticeMsg.ShowPromptMsg(fieldName + "值为'" + seleltext + "'时" + fieldcontrolName + "只能选择[" + name + "]");
                                            return false;
                                        }
                                    }
                                }
                                break;
                            default:
                                break;
                            }
                        }
                    }
                    break;
                case "Comment": {
                    switch(fieldcontrolType) {
                    case "Text":
                        var value = $("[filedname='" + fieldcontrol + "']").val();
                        if (value.trim() == "") {
                            var noticeMsg = new SinochemPromptMsg("W", 3000);
                            noticeMsg.ShowPromptMsg("请输入" + fieldcontrolName);
                            return false;
                        }
                        break;
                    default:
                        break;
                    }

                }
                case "Div": {
                    /*fieldKey==fieldcontrol表示fieldKey字段为必填项*/
                    if (fieldKey == fieldcontrol) {
                        var textval = getLocVal(fieldcontrol + "_Items");
                        if (fieldcontrolValue == "非空") {
                            if (textval == "[]") {
                                var noticeMsg = new SinochemPromptMsg("W", 3000);
                                noticeMsg.ShowPromptMsg("请选择" + fieldcontrolName);
                                return false;
                            }
                        }
                    }
                    break;
                }
                default:
                    break;
                }
            }
        }
    }
    return true;
}

/*------------------------------------------------------------------------------------------------------*/

/*根据泛微接口返回的一系列值返回不同的显示控件*/
function GetShowHtml(obj, index, IsGetControl, IsAddPage) {
    /*字段显示html类型*/
    var fieldHtmlType = obj.fieldHtmlType;
    /*字段是否可编辑*/
    var edit = obj.edit;
    /*字段类型*/
    var fieldType = obj.fieldType;
    /*字段显示值*/
    var fieldShowValue = obj.fieldShowValue;
    /*字段是否必填*/
    var mand = obj.mand;
    /*字段排序*/
    var fieldOrder = obj.fieldOrder;
    /*字段排序*/
    var fieldValue = obj.fieldValue;
    /*字段数据库类型*/
    var fieldDBType = obj.fieldDBType;
    /*字段数据库名*/
    var fieldName = obj.fieldName;
    fieldShowValue = fieldShowValue.replace("<span style='color:#ACA899'>[该字段暂不支持]</span>", "");
    fieldShowValue = fieldShowValue.replace("<span style='color:#ACA899'>[该字段仅支持显示]</span>", "");
    fieldShowValue = fieldShowValue.replace(/href=/g, "");
    fieldShowValue = fieldShowValue.replace(/style=/g, "");
    var strHtml = "";
    if (fieldShowValue.indexOf('<') < 0 && fieldShowValue.indexOf('/>') < 0) {
        strHtml = '<div class="tx-l blackFont LineShowValue" id=\'data' + index + '\' data-Index=\'' + index + '\' valuetype="lable" filedname=\'' + fieldName + '\' fieldValue=\'' + fieldValue + '\' >' + fieldShowValue + '</div>';
    } else {
        strHtml = '<div class="tx-l blackFont LineShowValue" id=\'data' + index + '\' data-Index=\'' + index + '\' valuetype="lable" filedname=\'' + fieldName + '\' fieldValue=\'\' >' + fieldShowValue + '</div>';
    }
    if (IsGetControl && edit) {
        var EditHtml = '';
        if (!IsAddPage) {
            EditHtml = '<div class="imgedit sicon-size ub-img5" ></div>';
        }
        switch(fieldHtmlType) {
        case "1":
            /*普通文本框*/
            if (fieldType == "1" || (fieldType == "" && fieldName == "requestname" && edit)) {
                if (mand) {
                    strHtml = '<textarea filedname=\'' + fieldName + '\' rows="1" valuetype="textarea" placeholder="（必填项）" id=\'data' + index + '\' data-Index=\'' + index + '\' type="text" class="ub ub-f1 ub-ac tx-l ulev0 CommonText blackFont mar-t" >' + fieldShowValue.replace(/<br>/g, "\r\n") + '</textarea>';
                } else {
                    strHtml = '<textarea  filedname=\'' + fieldName + '\' rows="1" valuetype="textarea" type="text" id=\'data' + index + '\' data-Index=\'' + index + '\' class="ub ub-f1 ub-ac tx-l ulev0 CommonText blackFont mar-t" >' + fieldShowValue.replace(/<br>/g, "\r\n") + '</textarea>';
                }
                strHtml += EditHtml;
            }
            /*数字文本框*/
            else if (fieldType == "2" || fieldType == "3") {
                if (mand) {
                    strHtml = '<input filedname=\'' + fieldName + '\' placeholder="（必填项）" maxlength=' + GetMaxLengthByType(fieldDBType) + ' valuetype="text" type="number" id=\'data' + index + '\' data-Index=\'' + index + '\' class="ub ub-f1 ub-ac tx-l ulev0 CommonText blackFont mar-t"  value=\'' + fieldShowValue + '\'>';
                } else {
                    strHtml = '<input filedname=\'' + fieldName + '\' type="number" maxlength=' + GetMaxLengthByType(fieldDBType) + '  valuetype="text" id=\'data' + index + '\' data-Index=\'' + index + '\' class="ub ub-f1 ub-ac tx-l ulev0 CommonText blackFont mar-t"  value=\'' + fieldShowValue + '\'>';
                }
                strHtml += EditHtml;
            }

            break;
        case "2":
            /*文本域*/
            if (fieldType == "1") {
                if (mand) {
                    strHtml = '<textarea filedname=\'' + fieldName + '\' rows="1" valuetype="textarea" placeholder="（必填项）" id=\'data' + index + '\' data-Index=\'' + index + '\' type="text" class="ub ub-f1 ub-ac tx-l ulev0 CommonText blackFont mar-t" >' + fieldShowValue.replace(/<br>/g, "\r\n") + '</textarea>';
                } else {
                    strHtml = '<textarea  filedname=\'' + fieldName + '\' rows="1" valuetype="textarea" type="text" id=\'data' + index + '\' data-Index=\'' + index + '\' class="ub ub-f1 ub-ac tx-l ulev0 CommonText blackFont mar-t" >' + fieldShowValue.replace(/<br>/g, "\r\n") + '</textarea>';
                }
            }
            strHtml += EditHtml;
            break;
        case "3":
            /*日期*/
            if (fieldType == "2") {
                if (mand) {
                    strHtml = '<input filedname=\'' + fieldName + '\' type="text" readonly onclick="openInputDatePicker(this)" valuetype="text" id=\'data' + index + '\' data-Index=\'' + index + '\' placeholder="（必填项）"  class="ub ub-f1 ub-ac tx-l ulev0 CommonText blackFont mar-t"  value=\'' + fieldShowValue + '\' />';
                } else {
                    strHtml = '<input filedname=\'' + fieldName + '\' type="text" readonly onclick="openInputDatePicker(this)" valuetype="text" id=\'data' + index + '\' data-Index=\'' + index + '\'  class="ub ub-f1 ub-ac tx-l ulev0 CommonText blackFont mar-t"  value=\'' + fieldShowValue + '\' />';
                }
                strHtml += EditHtml;
            }
            /*时间*/
            else if (fieldType == "19") {
                if (mand) {
                    strHtml = '<input filedname=' + fieldName + ' type="text" readonly onclick="openInputTimePicker(this)" valuetype="text" placeholder="（必填项）" id=\'data' + index + '\' data-Index=\'' + index + '\' class="ub ub-f1 ub-ac tx-l ulev0 CommonText blackFont mar-t"  value=\'' + fieldShowValue + '\' />';
                } else {
                    strHtml = '<input filedname=' + fieldName + ' type="text" readonly onclick="openInputTimePicker(this)" valuetype="text" id=\'data' + index + '\' data-Index=\'' + index + '\' class="ub ub-f1 ub-ac tx-l ulev0 CommonText blackFont mar-t"  value=\'' + fieldShowValue + '\' />';
                }
                strHtml += EditHtml;
            }
            /*选年份*/
            else if (fieldType == "178") {
                var selectstyle = "blackFont";
                if (obj.fieldValue[0] == "") {
                    selectstyle = "grayFont";
                }
                if (mand) {
                    strHtml = " <select filedname=" + fieldName + "  onchange=\"selectChange0(this);\" valuetype='select' id=\'data" + index + "\' data-Index=\'" + index + "\' class='imgDrop ub ub-f1 ub-ac tx-l ulev0 CommonText  mar-t " + selectstyle + "\' >";
                    strHtml += "  <option value=''>（必填项）</option>";
                } else {
                    strHtml = " <select filedname=" + fieldName + "  onchange=\"selectChange0(this);\" valuetype='select' id=\'data" + index + "\' data-Index=\'" + index + "\' class='imgDrop ub ub-f1 ub-ac tx-l ulev0 CommonText mar-t " + selectstyle + "\'>";
                    strHtml += "  <option value=''>请选择</option>";
                }

                var myDate = new Date();
                var year = myDate.getFullYear();

                for (var i = 0; i < 10; i++) {
                    if (fieldValue == (year + i)) {
                        strHtml += "<option value='" + (year - i) + "' selected='selected'>" + (year - i) + "</option>";
                    } else {
                        strHtml += "<option value='" + (year - i) + "'>" + (year - i) + "</option>";
                    }
                }
                strHtml += "  </select>";
                //strHtml += '<div class="imgDrop sicon-size ub-img5" ';
            }
            /*选人力资源、多人力资源、部门*/
            else if (fieldType == "1" || fieldType == "17" || fieldType == "4" || fieldType == "164" || fieldType == "57" || fieldType == "194") {
                var SpellData = new Array();
                var namearry = fieldShowValue.split(" ");
                var valuearry = fieldValue.split(",");
                if (valuearry.length > 1) {
                    for (var m in valuearry) {
                        if (valuearry[m] != "") {
                            var sd = {
                                itemName : namearry[m],
                                itemID : valuearry[m]
                            }
                            SpellData.push(sd);
                        }
                    }
                } else {
                    if (valuearry[0] != "") {
                        var sd = {
                            itemName : fieldShowValue,
                            itemID : valuearry[0]
                        }
                        SpellData.push(sd);
                    }
                }

                setLocVal(fieldName + "_Items", jsonToStr(SpellData));
                if (mand) {
                    fieldShowValue = (fieldShowValue == "" ? "（必填项）" : fieldShowValue);
                    if (fieldShowValue == "（必填项）") {
                        strHtml = '<div valuetype="Department" id=\'data' + index + '\' data-Index=\'' + index + '\' filedname=' + fieldName + ' class="ub ub-f1 ub-ac tx-l  CommonText blackFont" ><span class="grayFont">（必填项）</span></div>';
                    } else {
                        strHtml = '<div valuetype="Department" id=\'data' + index + '\' data-Index=\'' + index + '\' filedname=' + fieldName + ' class="ub ub-f1 ub-ac tx-l  CommonText blackFont" >' + GetOrgnizationShowHtml(fieldName, SpellData) + '</div>';
                    }
                } else {
                    strHtml = '<div valuetype="Department" id=\'data' + index + '\' data-Index=\'' + index + '\' filedname=' + fieldName + ' class="ub ub-f1 ub-ac tx-l  CommonText blackFont" >' + GetOrgnizationShowHtml(fieldName, SpellData) + '</div>';
                }
                //参数1：1多选，2单选
                //参数2：显示数据类型 0部门，1人员 ，2分部
                var addImg = "";
                /*选择单人员*/
                if (fieldType == "1") {
                    addImg = '<div class="imgAdd sicon-size ub-img5" onclick="SelectOrgnization(this,2,1)" ></div>';
                }
                /*选择多人员*/
                else if (fieldType == "17") {
                    addImg = '<div class="imgAdd sicon-size ub-img5" onclick="SelectOrgnization(this,1,1)" ></div>';
                }
                /*选择单部门*/
                else if (fieldType == "4") {
                    addImg = '<div class="imgAdd sicon-size ub-img5" onclick="SelectOrgnization(this,2,0)" ></div>';
                }
                /*选择多部门*/
                else if (fieldType == "57") {
                    addImg = '<div class="imgAdd sicon-size ub-img5" onclick="SelectOrgnization(this,1,0)" ></div>';
                }
                /*选择单分部*/
                else if (fieldType == "164") {
                    addImg = '<div class="imgAdd sicon-size ub-img5" onclick="SelectOrgnization(this,2,2)" ></div>';
                }
                /*选择多分部*/
                else if (fieldType == "194") {
                    addImg = '<div class="imgAdd sicon-size ub-img5" onclick="SelectOrgnization(this,1,2)" ></div>';
                }
                strHtml += addImg;
                /*休假类别*/
            } else if (fieldType == "161") {
                var typearry = [];
                var selectstyle = "blackFont";
                if (obj.fieldValue == "") {
                    selectstyle = "grayFont";
                }
                if (mand) {
                    strHtml = " <select filedname=" + fieldName + "  onchange=\"selectChange0(this);\" valuetype='select' id=\'data" + index + "\' data-Index=\'" + index + "\' class='imgDrop ub ub-f1 ub-ac tx-l  CommonText " + selectstyle + "\' >";
                    strHtml += "  <option value=''>（必填项）</option>";
                } else {
                    strHtml = " <select filedname=" + fieldName + "  onchange=\"selectChange0(this);\" valuetype='select' id=\'data" + index + "\' data-Index=\'" + index + "\' class='imgDrop ub ub-f1 ub-ac tx-l  CommonText " + selectstyle + "\'>";
                    strHtml += "  <option value=''>请选择</option>";
                }
                strHtml += "  </select>";

            }
            /*选择办理何种证件*/
            else if (fieldType == "162") {
                var SpellData = new Array();
                var namearry = new Array();
                if (fieldShowValue.indexOf("</a>") >= 0) {
                    fieldShowValue = fieldShowValue.replace(/<a[^>]*>/g, '');
                    fieldShowValue = fieldShowValue.replace(/<\/a>/g, '');
                    namearry = fieldShowValue.split('&nbsp');
                } else {
                    namearry = fieldShowValue.split(" ");
                }
                var valuearry = fieldValue.split(",");
                if (valuearry.length > 1) {
                    for (var m in valuearry) {
                        if (valuearry[m] != "") {
                            var sd = {
                                itemName : namearry[m],
                                itemID : valuearry[m]
                            }
                            SpellData.push(sd);
                        }
                    }
                } else {
                    if (valuearry[0] != "") {
                        var sd = {
                            itemName : fieldShowValue,
                            itemID : valuearry[0]
                        }
                        SpellData.push(sd);
                    }
                }
                setLocVal(fieldName + "_Items", jsonToStr(SpellData));
                if (mand) {
                    fieldShowValue = (fieldShowValue == "" ? "（必填项）" : fieldShowValue);
                    if (fieldShowValue == "（必填项）") {
                        strHtml = '<div valuetype="Department" id=\'data' + index + '\' data-Index=\'' + index + '\' filedname=' + fieldName + ' class="ub ub-f1 ub-ac tx-l  CommonText blackFont" ><span class="grayFont">' + fieldShowValue + '</span></div>';
                    } else {
                        strHtml = '<div valuetype="Department" id=\'data' + index + '\' data-Index=\'' + index + '\' filedname=' + fieldName + ' class="ub ub-f1 ub-ac tx-l  CommonText blackFont" >' + GetOrgnizationShowHtml(fieldName, SpellData) + '</div>';
                    }
                } else {
                    strHtml = '<div valuetype="Department" id=\'data' + index + '\' data-Index=\'' + index + '\' filedname=' + fieldName + ' class="ub ub-f1 ub-ac tx-l  CommonText blackFont" >' + GetOrgnizationShowHtml(fieldName, SpellData) + '</div>';
                }
                var fieldDBType = obj.fieldDBType;
                if (fieldDBType == "browser.bm_fb") {
                    strHtml += '<div class="imgAdd sicon-size ub-img5" onclick="SelectOrgnization(this,1,3)" ></div>';
                } else if (fieldDBType == "browser.qtjg") {
                    strHtml += '<div class="imgAdd sicon-size ub-img5" onclick="SelectOrgnization(this,1,0)" ></div>';
                } else if (fieldDBType == "browser.hzzj") {
                    strHtml += '<div class="imgAdd sicon-size ub-img5" onclick="SelectApplyInfo(this,1)" ></div>';
                }
                /*选择领导*/
            } else if (fieldType == "160") {
                var SpellData = new Array();
                var namearry = fieldShowValue.split(" ");
                var valuearry = fieldValue.split(",");
                if (valuearry.length > 1) {
                    for (var m in valuearry) {
                        if (valuearry[m] != "") {
                            var sd = {
                                itemName : namearry[m],
                                itemID : valuearry[m]
                            }
                            SpellData.push(sd);
                        }
                    }
                } else {
                    if (valuearry[0] != "") {
                        var sd = {
                            itemName : fieldShowValue,
                            itemID : valuearry[0]
                        }
                        SpellData.push(sd);
                    }
                }
                setLocVal(fieldName + "_Items", jsonToStr(SpellData));
                if (mand) {
                    fieldShowValue = (fieldShowValue == "" ? "（必填项）" : fieldShowValue);
                    if (fieldShowValue == "（必填项）") {
                        strHtml = '<div valuetype="Department" id=\'data' + index + '\' data-Index=\'' + index + '\' filedname=' + fieldName + ' class="ub ub-f1 ub-ac tx-l  CommonText blackFont" ><span class="grayFont">' + fieldShowValue + '</span></div>';
                    } else {
                        strHtml = '<div valuetype="Department" id=\'data' + index + '\' data-Index=\'' + index + '\' filedname=' + fieldName + ' class="ub ub-f1 ub-ac tx-l  CommonText blackFont" >' + GetOrgnizationShowHtml(fieldName, SpellData) + '</div>';
                    }
                } else {
                    strHtml = '<div valuetype="Department" id=\'data' + index + '\' data-Index=\'' + index + '\' filedname=' + fieldName + ' class="ub ub-f1 ub-ac tx-l  CommonText blackFont " >' + GetOrgnizationShowHtml(fieldName, SpellData) + '</div>';
                }
                if (getLocVal("OrgCode") == "1005") {
                    strHtml += '<div class="imgAdd sicon-size ub-img5" onclick="SelectOrgnization(this,1,4)" ></div>';
                } else {
                    strHtml += '<div class="imgAdd sicon-size ub-img5" onclick="SelectOrgnization(this,1,1)" ></div>';
                }
            }
            break;
        case "4":
            /*单选框*/
            if (fieldType == "1") {
                if (fieldValue == 1) {
                    strHtml = '<div class="checkbox umar-r CommonText mar-t "><input type="checkbox" valuetype="check" id=\'data' + index + '\' data-Index=\'' + index + '\' filedname=' + fieldName + ' checked=\'checked\' class="uabs ub-con" ></div>';
                } else {
                    strHtml = '<div class="checkbox umar-r CommonText mar-t "><input type="checkbox" valuetype="check" id=\'data' + index + '\' data-Index=\'' + index + '\' filedname=' + fieldName + '  class="uabs ub-con" ></div>';
                }
            }
            break;
        case "5":
            /*下拉列表*/
            if (fieldType == "1") {
                var selectstyle = "blackFont";
                if (obj.fieldValue == "") {
                    selectstyle = "grayFont";
                }
                if (mand) {
                    strHtml = " <select filedname=" + fieldName + " onchange=\"selectChange0(this);\" valuetype='select' id=\'data" + index + "\' data-Index=\'" + index + "\' class='imgDrop ub ub-f1 ub-ac tx-l ulev0 CommonText mar-t " + selectstyle + "\' >";
                    strHtml += "  <option value=''>（必填项）</option>";
                } else {
                    strHtml = " <select filedname=" + fieldName + " onchange=\"selectChange0(this);\" valuetype='select' id=\'data" + index + "\' data-Index=\'" + index + "\' class='imgDrop ub ub-f1 ub-ac tx-l ulev0 CommonText mar-t " + selectstyle + "\'>";
                    strHtml += "  <option value=''>请选择</option>";
                }
                for (var i = 0; i < obj.selectnames.string.length; i++) {
                    if (obj.fieldValue == obj.selectvalues.string[i]) {
                        strHtml += "<option value='" + obj.selectvalues.string[i] + "'  selected='selected'>" + obj.selectnames.string[i] + "</option>";
                    } else {
                        strHtml += "<option value='" + obj.selectvalues.string[i] + "'>" + obj.selectnames.string[i] + "</option>";
                    }
                }
                strHtml += "  </select>";
            }
            break;
        default:
            break;
        }
    }
    /*附件*/
    if ((fieldHtmlType == "3" && (fieldType == "9" || fieldType == "37")) || (fieldHtmlType == "6" && fieldType == "1")) {
        fieldShowValue.replace(/blue/g, "#000000");
        var docidarry = fieldValue.split(',');
        var docList = [];
        if (IsAddPage) {
            var SpellData = new Array();
            strHtml = '<div valuetype="Image" id=\'data' + index + '\' data-Index=\'' + index + '\' filedname=' + fieldName + ' class="ub ub-f1 ub-ac tx-l ulev0 CommonText blackFont mar-t2" >' + GetOrgnizationShowHtml(fieldName, SpellData) + '</div>';
            strHtml += '<div class="imgAdd sicon-size ub-img5" onclick="openImg(this)" ></div>';
        } else {
            try {
                strHtml = "<div class='ub ub-f1 ub-ver' filedname=" + fieldName + " >";
                // if(fieldShowValue=="")
                // {
                // strHtml += '<img style="width:100%;" onclick="ImgBrowser(this)" class="ub-img5 grid_icon imgup" src="data:image/png;base64,'+fieldValue+'"/>';
                // }
                if (fieldShowValue.indexOf("附件已与正文相关联") >= 0) {
                    strHtml += "<div class='tx-l blackFont LineShowValue' style='width:100%'>" + fieldShowValue + "</div>";
                } else {
                    if (fieldShowValue.indexOf('附件:') > 0) {
                        var docname = fieldShowValue.substring(fieldShowValue.lastIndexOf("filename=") + 9, fieldShowValue.lastIndexOf('\','));
                        docname = docname.replace(/%/g, '%25');
                        docList.push({
                            id : docidarry[0],
                            name : decodeURIComponent(docname)
                        });
                    } else {
                        fieldShowValue = fieldShowValue.split("<br/><br/>");
                        for (var i = 0; i < fieldShowValue.length; i++) {
                            //发文
                            if (fieldShowValue[i].indexOf('fileid=') > 0) {
                                var docname = fieldShowValue[i].substring(fieldShowValue[i].indexOf("filename=") + 9, fieldShowValue[i].indexOf('\','));
                                docname = docname.replace(/%/g, '%25');
                                docList.push({
                                    id : docidarry[i],
                                    name : decodeURIComponent(docname)
                                });
                            }
                            //便函
                            if (fieldShowValue[i].indexOf('keyid=') > 0) {
                                var docname = fieldShowValue[i].substring(fieldShowValue[i].indexOf(">") + 1, fieldShowValue[i].indexOf('</span>'));
                                docname = docname.replace(/%/g, '%25');
                                docList.push({
                                    id : docidarry[i],
                                    name : decodeURIComponent(docname)
                                });
                            }
                        }
                    }
                    if (docList.length) {
                        if (fieldName == "fg") {
                            for (var i = 0; i < docList.length; i++) {
                                var fileid = docList[i].id;
                                var fileName = docList[i].name;
                                strHtml += '<div class="ub" style="margin-left:1em;padding-bottom:.5em">';
                                strHtml += '<div class="imgfile sicon-size ub-img5"></div>';
                                strHtml += " <div class='ub blackFont' style='margin-left:.5em;margin-right:.8em;word-break: break-all;' onclick=\"openDetail(" + fileid + ",'" + fileName + "')\" >" + fileName + "</div>";
                                strHtml += "</div>";
                            }
                        } else if (fieldName == "zw" || fieldName == "nbfw010" || fieldName == "nbqs010") {
                            var fileid = docList[0].id;
                            var fileName = docList[0].name;
                            strHtml += '<div class="ub" style="margin-left:1em;padding-bottom:.5em">';
                            strHtml += '<div class="imgfile sicon-size ub-img5"></div>';
                            strHtml += " <div class='ub blackFont' style='margin-left:.5em;margin-right:.8em;word-break: break-all;' onclick=\"openZhengwen(" + fileid + ",'" + fileName + "')\" >" + fileName + "</div>";
                            strHtml += "</div>";
                        } else {
                            for (var i = 0; i < docList.length; i++) {
                                var fileid = docList[i].id;
                                var fileName = docList[i].name;
                                if (fileid != "" && fileName != "") {
                                    strHtml += '<div class="ub" style="margin-left:1em;padding-bottom:.5em">';
                                    strHtml += '<div class="imgfile sicon-size ub-img5"></div>';
                                    strHtml += " <div class='ub blackFont' style='margin-left:.5em;margin-right:.8em;word-break: break-all;' onclick=\"openFile(" + fileid + ",'" + fileName + "')\" >" + fileName + "</div>";
                                    strHtml += "</div>";
                                }

                            }
                        }
                    }
                }
            } catch(ex) {

            }
        }
        strHtml += "</div>";
    }

    return strHtml;
}

function openDetail(id, name) {
    setLocVal('fwtitle', '附稿');
    setLocVal("dispatchDocID", id);
    setLocVal("dispatchDocName", name);
    setLocVal('fileID',id);
    setLocVal('version',"");
    setLocVal('fileName',name);
    setLocVal('docImageFileId',"");
    setLocVal("isShowFile","Y");
    downFile();
   
}

function openZhengwen(id, name) {
    setLocVal('fwtitle', '正文');
    setLocVal("dispatchDocID", id);
    setLocVal("dispatchDocName", name);
    setLocVal('fileID',id);
    setLocVal('version',"");
    setLocVal('fileName',name);
    setLocVal('docImageFileId',"");
    setLocVal("isShowFile","Y");
    downFile();
}

/*绑定请假、出差类型*/
function GetLeaveClassList(fieldValue, _functionName, _fieldName) {
    var usercode = getLocVal("usercode") || "zhangmh@sinochem.com";
    var selecthtml = "";
    var functionName = (_functionName && _functionName != "" ) ? _functionName : "GetLeaveClass";
    var fieldName = (_fieldName && _fieldName != "") ? _fieldName : "xjlb";
    var parms = {
        APPID : appID,
        UserCode : usercode,
        OrgCode : getLocVal("OrgCode") || "1005"
    };

    var returndata = {
        status : 0,
        msg : "",
        data : []
    };
    callAjaxService("GET", functionName, parms, true, function(data) {
        if (data) {
            if (data.ResultCode == '0' && data.Data.length > 0) {
                for (var i = 0; i < data.Data.length; i++) {
                    var dataobj = {
                        "Name" : data.Data[i].TIMEITEMNAME,
                        "Code" : data.Data[i].TIMEITEMCODE
                    };
                    returndata.data.push(dataobj);
                };
            }
            typearry = returndata.data;

            for (var i in typearry) {
                if (fieldValue && fieldValue == typearry[i].Code) {
                    selecthtml += "<option value='" + typearry[i].Code + "' selected='selected'>" + typearry[i].Name + "</option>";
                } else {
                    selecthtml += "<option value='" + typearry[i].Code + "'>" + typearry[i].Name + "</option>";
                }
            }
            $('[filedname="' + fieldName + '"]').append(selecthtml);
        }

    }, function(Result) {
        returndata.status = 9;
        returndata.msg = '获取数据失败！';
    });

}

/*打开附件详情页面*/
function openFile(id, fileName, interName) {
    var FileExtArry = fileName.split(".");
    if (!ValidFileExt(FileExtArry[FileExtArry.length - 1])) {
        var noticeMsg = new SinochemPromptMsg("M", 3000);
        noticeMsg.ShowPromptMsg("暂不支持该格式，请前往PC端查看");
        return;
    }
  
    setLocVal("fileid", id);
    setLocVal("filename", fileName);
    setLocVal("fileVersion");
    if (getLocVal("dbczzid") != getLocVal("userid")) {
        var parmFile = {
            "userId" : getLocVal("dbczzid")
        };
        callAjaxService("GET", "GetUserCodeByID", parmFile, true, function(json) {
            if (json != null) {
                getAttContent(id, fileName, interName, json.Data.loginId);
            }
        }, function(Result) {
            var warningMsg = new SinochemPromptMsg("W", 3000);
            warningMsg.ShowPromptMsg("网络超时，请重试！");
        });
    } else {
        var userName = getLocVal('usercode');
        getAttContent(id, fileName, interName, userName);
    }
}

//获取附件
function getAttContent(id, fileName, interName, userName) {
    var password = encryptText(userName);
    //showToast('请稍候...');
    loadingMsg.ShowLoadingMsg("请稍候...");
    var parmFile = {
        "fileID" : id,
        "fileName" : fileName,
        "userName" : userName,
        "password" : password
    };
    callAjaxService("GET", interName ? interName : "Transit_ConvertAttachmentFile", parmFile, true, function(json) {
        if (json != null) {
            json.pagecount = parseInt(json.pagecount);
            if (json && json.pagecount) {
                 checkPDF(id, json.pagecount, json.AesCode,fileName,"",id);
            } else {
                var noticeMsg = new SinochemPromptMsg("M", 3000);
                noticeMsg.ShowPromptMsg("没有获取到附件");
                return;
            }
            loadingMsg.HideMsg();
        }
    }, function(Result) {
        loadingMsg.HideMsg();
        warningMsg.ShowPromptMsg("网络超时，请重试！");
    });
}

function checkPDF(fileID, pages, aesCode,fileName,docImageFileId,id) {
    var paths = [];
    if (aesCode != "[object Object]") {
        fileID = fileID + aesCode;
    }
    for (var i = 1; i <= pages; i++) {
        var index = i < 10 ? '00' + i : i < 100 ? '0' + i : '' + i;
        paths.push({
                src : masip + '/Transit_GetOADocPic?fileID=' + fileID + '&index=' + index,
                thumb : "",
                desc : ""
            }
        );
    }
    try {
        var json = JSON.stringify(paths);
        setLocVal("ImageBrowserPageImg",json);
        setLocVal('fileID',id);
        setLocVal('version',aesCode);
        setLocVal('fileName',fileName);
        setLocVal('docImageFileId',docImageFileId);
        setLocVal("isShowFile","N");
        openFilepopover();
        //uexImage.openBrowser(json);
    } catch(e) {
        alert("图片不能浏览");
    }
}

function openFilepopover() {
    downFile();
}

function downFile() {
   var userName = getLocVal('usercode');
   var password =encryptText(userName);
   var fileID= getLocVal('fileID');
   var version= getLocVal('version');
   var fileName= getLocVal('fileName');
   var docImageFileId=getLocVal('docImageFileId');
   var url=Documentmasip + '/JinMaoMas/Transit_GetOADoc?fileID=' + fileID +"&version=" + version+"&fileName="+fileName+"&docImageFileId="+docImageFileId;
   url+="&userName="+userName+"&password="+password;
   openpage(url);
}



/*调用选择部门和人员页面*/
function SelectOrgnization(obj, selectType, sDataType) {
    setLocVal("selectType", selectType);
    setLocVal("sDataType", sDataType);
    var key = $(obj).prev("div").attr("filedname");
    setLocVal("CallPageName", key);
    switch(sDataType) {
    case 4:
        openWin('SelectLeader', '../SelectLeader.html');
        break;
    default:
        openWin('SelectOrgnization', '../SelectOrgnization.html');
        break;
    }

    appcan.window.subscribe("refreshDepartment", function(msg) {
        var ihtml = GetOrgnizationShowHtml(key, strToJson(getLocVal(key + "_Items")));
        $(obj).prev("div").html(ihtml);
    });
    appcan.window.subscribe("refreshLeaders", function(msg) {
        var ihtml = GetOrgnizationShowHtml(key, strToJson(getLocVal(key + "_Items")));
        if (key == "ldjsry") {
            if ($("[filedname='ldhy']").length > 0) {
                var data = strToJson(getLocVal(key + "_Items"));
                var ldname = "";
                for (var i in data) {
                    ldname += data[i].itemName + " ";
                }
                $("[filedname='ldhy']").val(ldname);
            }
        }
        $(obj).prev("div").html(ihtml);
    });
}

/*选择请假相关证件*/
function SelectApplyInfo(obj, selectType) {
    setLocVal("selectType", selectType);
    var key = $(obj).prev("div").attr("filedname");
    setLocVal("CallPageName", key);
    openWin('SelectApplyInfo', '../SelectApplyInfo.html');
    appcan.window.subscribe("refreshApplyInfo", function(msg) {
        var ihtml = GetOrgnizationShowHtml(key, strToJson(getLocVal(key + "_Items")));
        $(obj).prev("div").html(ihtml);
        if (ihtml == "") {
            $(obj).prev("div").append('<span class="grayFont">（必填项）</span>');
        }
    });
}

/*获取机构显示的html*/
function GetOrgnizationShowHtml(key, data) {
    var deleteBtn = '<div class="fa fa-times inline" style="margin-left:.04rem;color:#E0E0E0"></div>';
    var ihtml = "";
    if (data && data.length > 0) {
        ihtml += "<div style='width:90%'>";
        for (var i in data) {
            ihtml += "<div style='padding:0 .1rem;float:left;margin-right:.1rem;' class='selectedItem uc-a1 ' key='" + key + "' itemID='" + data[i].itemID + "' onclick='RemoveDiv(this)'>" + data[i].itemName + "</div>";
        }
        ihtml += "</div>";
    }
    return ihtml;
}

/*删除Div块*/
function RemoveDiv(obj) {
    new SinochemConfirmationMsg("", function() {
        var key = $(obj).attr("key");
        var itemID = $(obj).attr("itemID");
        var data = strToJson(getLocVal(key + "_Items"));
        for (var i in data) {
            if (data[i].itemID == itemID) {
                data.splice(i, 1);
                break;
            }
        }
        setLocVal(key + "_Items", jsonToStr(data));
        if (key == "ldjsry") {
            if ($("[filedname='ldhy']").length > 0) {
                var data = strToJson(getLocVal(key + "_Items"));
                var ldname = "";
                for (var i in data) {
                    ldname += data[i].itemName + " ";
                }
                $("[filedname='ldhy']").val(ldname);
            }
        }
        var objparent = $(obj).parent();
        $(obj).remove();
        if ($(objparent).html().trim() == "") {
            $(objparent).remove();
        }
    }, 2).ShowConfirmationMsg("", "确定要删除[" + $(obj).html() + "]吗？");
}

function RemoveDivWithNoPrompt(obj) {
    var key = $(obj).attr("key");
    var itemID = $(obj).attr("itemID");
    var data = strToJson(getLocVal(key + "_Items"));
    for (var i in data) {
        if (data[i].itemID == itemID) {
            data.splice(i, 1);
            break;
        }
    }
    setLocVal(key + "_Items", jsonToStr(data));
    if (key == "ldjsry") {
        if ($("[filedname='ldhy']").length > 0) {
            var data = strToJson(getLocVal(key + "_Items"));
            var ldname = "";
            for (var i in data) {
                ldname += data[i].itemName + " ";
            }
            $("[filedname='ldhy']").val(ldname);
        }
    }
    var objparent = $(obj).parent();
    $(obj).remove();
    if ($(objparent).html().trim() == "") {
        $(objparent).remove();
    }
}

/*选择框选择事件*/
function selectChange0(obj) {
    var selectedIndex = obj.selectedIndex;
    if (selectedIndex == 0) {
        $(obj).css("color", "#999999");
    } else {
        $(obj).css("color", "#666666");
    }
}

/*根据数据库值类型返回最大输入值长度*/
function GetMaxLengthByType(Type) {
    var maxLength = "";
    if (Type.indexOf('varchar2') >= 0) {
        maxLength = Type.replace('varchar2', '').replace('(', '').replace(')', '');
    } else if (Type.indexOf('number') >= 0) {
        maxLength = Type.replace('number','').replace('(','').replace(')','').split(',')[0];
    } else if (Type.indexOf('integer') >= 0) {
        maxLength = 15;
    }
    return maxLength;
}

/*将字符串中的特殊字符进行编码*/
function DealString(str) {
    if (str != "" && str != null) {
        str = str.replace(/&/g, '&amp;');
        str = str.replace(/</g, '&lt;');
        str = str.replace(/>/g, '&gt;');
        str = str.replace(/'/g, '&apos;&apos;');
        str = str.replace(/"/g, '&quot;');
    }
    return str;
}

/*根据页面填写值，重新赋值RequestInfo里的属性值*/
function GetModifyData(RequestInfo, ismustcheck) {
    //下拉框选项
    var datas = $(".BaseData [data-Index]");
    try {
        for (var i = 0; i < datas.length; i++) {
            /*值索引*/
            var index = $(datas[i]).attr("data-Index");
            /*取值类型*/
            var type = $(datas[i]).attr("valuetype");
            var getValue = "";
            var getText = "";
            switch(type) {
            case "select":
                var selelindex = $(datas[i])[0].selectedIndex;
                getValue = $(datas[i])[0].options[selelindex].value;
                getText = $(datas[i])[0].options[selelindex].text;
                break;
            case "text":
                var obj = $(datas[i]);
                getValue = obj.val();
                getText = obj.val();
                break;
            case "textarea":
                var obj = $(datas[i]);
                getValue = obj.val();
                getText = obj.val();
                break;
            case "check":
                var obj = $(datas[i]);
                getValue = obj.is(":checked") ? "1" : "0";
                getText = obj.is(":checked") ? "是" : "否";
                break;
            case "Department":
                var obj = $(datas[i]);
                var filename = obj.attr("filedname");
                var filedvalue = strToJson(getLocVal(filename + "_Items"));
                for (var j in filedvalue) {
                    getText += filedvalue[j].itemName + " ";
                    getValue += filedvalue[j].itemID + ",";
                }
                if (getText != "") {
                    getText = getText.substr(0, getText.length - 1);
                }
                if (getValue != "") {
                    getValue = getValue.substr(0, getValue.length - 1);
                }
                break;
            case "Image":
                var obj = $(datas[i]);
                var filename = obj.attr("filedname");
                if (imgLocalPath.length > 0) {
                    var filedvalue = imgLocalPath;
                    var filedType = "";
                    var m = 0;
                    for (var j in filedvalue) {
                        m++;
                        getText = "附件";
                        filedType += "base64:附件" + m + ".jpg|";
                        getValue += filedvalue[j].baseCode + "|";
                        //baseCode是base64转码后的值
                    }
                    RequestInfo.workflowMainTableInfo.requestRecords.WorkflowRequestTableRecord[0].workflowRequestTableFields.WorkflowRequestTableField[index].fieldType = filedType;
                }
                break;
            case "lable":
                var obj = $(datas[i]);
                getValue = obj.attr("fieldValue");
                getText = obj.html();
                break;
            default:
                break;
            }
            getText = DealString(getText);
            getValue = DealString(getValue);
            if (ismustcheck) {
                if (RequestInfo.workflowMainTableInfo.requestRecords.WorkflowRequestTableRecord[0].workflowRequestTableFields.WorkflowRequestTableField[index].mand == true) {
                    var name = RequestInfo.workflowMainTableInfo.requestRecords.WorkflowRequestTableRecord[0].workflowRequestTableFields.WorkflowRequestTableField[index].fieldShowName;
                    switch(type) {
                    case "select":
                        if (getText == "（必填项）") {
                            var noticeMsg = new SinochemPromptMsg("W", 3000);
                            noticeMsg.ShowPromptMsg("请选择" + name);
                            return false;
                        }
                        break;
                    case "text":
                        if (getText == "") {
                            var noticeMsg = new SinochemPromptMsg("W", 3000);
                            noticeMsg.ShowPromptMsg("请输入" + name);
                            return false;
                        }
                        break;
                    case "textarea":
                        if (getText == "") {
                            var noticeMsg = new SinochemPromptMsg("W", 3000);
                            noticeMsg.ShowPromptMsg("请输入" + name);
                            return false;
                        }
                        break;
                    case "Department":
                        if (getText == "") {
                            var noticeMsg = new SinochemPromptMsg("W", 3000);
                            noticeMsg.ShowPromptMsg("请选择" + name);
                            return false;
                        }
                        break;
                    default:
                        break;
                    }

                }
            }
            if (RequestInfo.workflowMainTableInfo.requestRecords.WorkflowRequestTableRecord[0].workflowRequestTableFields.WorkflowRequestTableField[index].edit) {
                RequestInfo.workflowMainTableInfo.requestRecords.WorkflowRequestTableRecord[0].workflowRequestTableFields.WorkflowRequestTableField[index].fieldValue = getValue;
                RequestInfo.workflowMainTableInfo.requestRecords.WorkflowRequestTableRecord[0].workflowRequestTableFields.WorkflowRequestTableField[index].fieldShowValue = getText;
            } else {
                var filecode = RequestInfo.workflowMainTableInfo.requestRecords.WorkflowRequestTableRecord[0].workflowRequestTableFields.WorkflowRequestTableField[index].fieldName;
                /*休假时长和结余时间的特殊处理*/
                if (filecode == "xjsc" || filecode == "jysj") {
                    RequestInfo.workflowMainTableInfo.requestRecords.WorkflowRequestTableRecord[0].workflowRequestTableFields.WorkflowRequestTableField[index].fieldValue = getValue;
                    RequestInfo.workflowMainTableInfo.requestRecords.WorkflowRequestTableRecord[0].workflowRequestTableFields.WorkflowRequestTableField[index].fieldShowValue = getText;
                }
            }
        }
    } catch(ex) {
        logs("error:" + ex.message);
    }
    return true;
}

/*计算请休假时长*/
function GetLeaveApplyDateInfo() {
    //showToast("正在计算休假时长，请稍等...");
    loadingMsg.ShowLoadingMsg("正在计算休假时长，请稍等...");
    var selelindex = $("[filedname='xjlb']")[0].selectedIndex;
    var type = $("[filedname='xjlb']")[0].options[selelindex].value;
    var selelindex2 = $("[filedname='jqnd']")[0].selectedIndex;
    var year = $("[filedname='jqnd']")[0].options[selelindex2].value;
    var BeginDate = $("[filedname='ksrq']").val();
    var BeginTime = $("[filedname='kssk']").val();
    var EndDate = $("[filedname='jsrq']").val();
    var EndTime = $("[filedname='jssk']").val();
    var parmData = {
        "userCode" : LeaveApplyUserCode,
        "userid" : getLocVal("Mainuserid"),
        "corp" : getLocVal("OrgCode"),
        "type" : type,
        "year" : year,
        "BeginDate" : BeginDate,
        "BeginTime" : BeginTime,
        "EndDate" : EndDate,
        "EndTime" : EndTime
    };
    callAjaxService("GET", "getLeaveApplyDateInfo", parmData, true, function(data) {
        if (data != null) {
            var LeaveApplyDate = data.Data;
            callAjaxService("GET", "getQueryHoursLong", parmData, true, function(data) {
                if (data != null) {
                    var QueryHoursLong = data.Data;
                    $("[filedname='jysj']").html(LeaveApplyDate);
                    $("[filedname='xjsc']").html(QueryHoursLong);
                    $("[filedname='jysj']").attr("fieldValue", LeaveApplyDate);
                    $("[filedname='xjsc']").attr("fieldValue", QueryHoursLong);
                    loadingMsg.HideMsg();
                }
            }, function(Result) {
                loadingMsg.HideMsg();
                warningMsg.ShowPromptMsg("网络超时，请重试！");
            });
        }
    }, function(Result) {
        loadingMsg.HideMsg();
        warningMsg.ShowPromptMsg("网络超时，请重试！");
    });
}

//判断表单时是否填写了信息，若填写了信息，提示客户“返回上一个页面填写的信息将丢失”
function isValue() {
    setLocVal("userInput", false);
    //检查input是否有值
    var obj = $("input");
    $.each(obj, function(i, item) {
        if (item.type == "text" || item.type == "date" || item.type == "number" || item.type == "time") {
            if (item.value.length > 0) {
                setLocVal("userInput", true);
            }
        }
        if (item.type == "checkbox") {
            if (item.checked) {
                setLocVal("userInput", true);
            }
        }
    });
    //需要遍历所有的下拉框，当下拉框选项不为0时，表示用户选择过
    //但是有一个特殊情况，是否加签，我们设置了默认值：“否”，需要对它做特殊判断，用户只有选择了非“否”的选项才算编辑过
    var obj1 = $("select");
    $.each(obj1, function(i, item) {
        //
        //是否加签需要特殊判断
        //只有不为“否”才表示用户操作过
        //
        if ($(item).attr('filedname') == 'sfjq') {
            if (item.options.selectedIndex != 2) {
                setLocVal("userInput", true);
            }
        }
        //
        //其余选项，只要非0，则用户操作过
        //
        else if (item.options.selectedIndex > 0) {
            setLocVal("userInput", true);
        }
    });
    // $("select[filedname='sfjq'] option")
    // $("select[name=items]").find("option:selected").text();
    var obj2 = $("textarea");
    $.each(obj2, function(i, item) {
        if (item.value.length > 0) {
            setLocVal("userInput", true);
        }
    });
    var obj3 = $("[valuetype='Department']");
    $.each(obj3, function(i, item) {
        if ($(item).html().trim() != "" && $(item).html().indexOf("必填项") < 0) {
            if (!$(item).parent().hasClass("uhide")) {
                setLocVal("userInput", true);
            }
        }
    });
    appcan.window.publish('backLeaveApply', '返回申请页面');
}

/*生成审批语*/
function getApprovalMessage(workflowid, workflowTypeID, nodeName, nodeID) {
    // var workCode = getLocVal("workcode");workCode == "fw00010" &&
    var reg = /^[\s\S]*办公厅[\s\S]*批分[\s\S]*$/g;
    if (reg.test(nodeName))//李强主任审批的,办公厅审核（批分）节点
    {
        var leadersText = $('[filedname="' + xgldFieldName + '"]');
        var key = xgldFieldName;
        if (leadersText.length > 0) {
            leadersText.bind("DOMNodeInserted", function() {
                callMessageFun(workflowTypeID, nodeName, nodeID, key);
            });
            leadersText.bind("DOMNodeRemoved", function() {
                callMessageFun(workflowTypeID, nodeName, nodeID, key);
            });
        }
    } else {
        var CallData = {
            workflowID : workflowid,
            nodeID : nodeID
        };
        callAjaxService("GET", "IsNodeHasLeaderText", CallData, true, function(data) {
            if (data.data) {
                var leadersText = $('[filedname="' + data.data.filednameLeaders + '"]');
                var key = data.data.filednameLeaders;
                if (leadersText.length > 0) {
                    leadersText.bind("DOMNodeInserted DOMNodeRemoved", function() {
                        callMessageFunForAG(workflowid, nodeName, nodeID, key, data.data.WorkflowType, data.data.filednameDes);
                    });
                }
            }
        });
    }
}

/*指定流程特殊节点特殊处理*/
function callMessageFunForAG(workflowid, nodeName, nodeID, key, WorkflowType, filednameDes) {
    var userID = getLocVal("userid");
    var leaderObjs = JSON.parse(getLocVal(key + "_Items"));
    var leaderIDArray = new Array();
    if (leaderObjs.length <= 0) {
        $('[filedname="' + filednameDes + '"]').val("");
        return;
    }
    for (var i in leaderObjs) {
        leaderIDArray.push(leaderObjs[i].itemID);
    }
    var CallData = {
        WorkFlowTypeID : workflowid,
        NodeID : nodeID,
        Operator : userID,
        Leaders : leaderIDArray.join(","),
        WorkflowType : WorkflowType || '0'
    };
    callAjaxService("GET", "getAGApproveMessage", CallData, true, function(data) {
        if (data.data) {
            $('[filedname="' + filednameDes + '"]').val(data.data);
        }
    });
}

function callMessageFun(workflowTypeID, nodeName, nodeID, key) {
    var userID = getLocVal("userid");
    var leaderObjs = JSON.parse(getLocVal(key + "_Items"));
    var leaderIDArray = new Array();
    if (leaderObjs.length <= 0) {
        $('[filedname="bgspfyj"]').val("");
        $('[filedname="bgtpf"]').val("");
        return;
    }
    for (var i in leaderObjs) {
        leaderIDArray.push(leaderObjs[i].itemID);
    }
    var CallData = {
        WorkFlowTypeID : workflowTypeID,
        NodeID : nodeID,
        Operator : userID,
        Leaders : leaderIDArray.join(",")
    };
    callAjaxService("GET", "getApproveMessage", CallData, true, function(data) {
        if (data.data) {
            $('[filedname="bgspfyj"]').val(data.data);
            //$('#txtComment').val(data.data);
            $('[filedname="bgtpf"]').val(data.data);
            //$('[filedname="bgspfyj"]').focus();
            //$('[filedname="bgtpf"]').focus();
        }
    });
}

function getAttrInfo(attrInfo, cb) {
    var getDepData = {};
    for (var key in attrInfo) {
        getDepData[key] = attrInfo[key][0];
    }
    getDepData.workflowID = WorkFlowId;
    //getDepData.caltype = 1;
    callAjaxService("POST", "doFieldAttr", getDepData, true, function(data) {
        if (data.status == 0) {
            var xmldata = $("<div>" + data.msg + "</div>").text();
            xmldata = xmldata.replace('<?xml version="1.0"encoding="UTF-8"?>', '');
            var data = xml2json(xmldata);
            if (data.information.result == "SUCCESS") {
                if (cb) {
                    cb(data);
                }
            }
        }
    });
}

function getFieldTriggerInfo(triggerCallData, cb) {
    callAjaxService("GET", "doFieldTrigger", triggerCallData, true, function(result) {
        if (result.status == 0) {
            var xmldata = result.data.replace('<?xml version="1.0"encoding="UTF-8"?>', '');
            var infoData = "";
            var filedData = "";
            if ((/(<information>.*<\/information>)/g).test(xmldata)) {
                infoData = xml2json(RegExp.$1);
            }
            if ((/(<data>.*<\/data>)/g).test(xmldata)) {
                filedData = xml2json(RegExp.$1);
            }
            if (infoData.information.result == "SUCCESS") {
                if (cb) {
                    cb(filedData, infoData);
                }
            }
        }
    });
}

function GetReportLine(applicantID, cb) {
    //sql和datasource需要去pc端，用管理员进入后台的流程路径设置，找对应流程的字段联动设置里查看
    var triggerData = {
        //sql : "select cus_fielddata.FIELD11 from cus_fielddata where cus_fielddata.ID=" + applicantID,
        sql : "select cus_fielddata.FIELD0,cus_fielddata.FIELD1 from cus_fielddata where cus_fielddata.ID=" + applicantID,
        datasource : "local"
    };
    getFieldTriggerInfo(triggerData, function(filedData) {
        if (cb) {
            cb(filedData);
        }
    });
}

function GetUserByID(userID, cb) {
    callAjaxService("GET", "getAccountListByUserId", {
        userId : userID
    }, true, function(userData) {
        if (userData != null && userData.status == 0) {
            userData = JSON.parse(userData.data);
            //if (userData.length > 0) {
            if (cb) {
                cb(userData[0]);
            }
            //}
        }
    });
}

//上传图片的最大个数
var pictureMax = 2;

function openImg(obj) {
    if (imgLocalPath.length >= pictureMax) {
        warningMsg.ShowPromptMsg("最多允许上传" + pictureMax + "个附件！");
        //alert("最多允许上传" + pictureMax + "个附件！");
        return;
    }
    var key = $(obj).prev("div").attr("filedname");
    uexWindow.cbActionSheet = function(id, dataType, data) {
        if (data == 0) {
            openCamera(key, obj);
        } else if (data == 1) {
            pickImg(key, obj);
        }
    };
    var btnTextA = ["拍摄照片", "本地图片"];
    uexWindow.actionSheet("操作", "取消", btnTextA);
}

function openCamera(key, obj) {
    logs("openCamera-begin");
    try {
        uexCamera.cbOpen = function(opCode, dataType, data) {
            logs("cbopenCamera-begin");
            var imgInfo = [{
                "data" : data
            }];
            logs("data:" + data);
            writePic(imgInfo[0].data, key, obj);
            logs("cbopenCamera-end");
        }
        var quality = 40;
        if (!isAndroid) {
            quality = 40;
        }
        uexCamera.open(0, quality);
        logs("openCamera-end");
    } catch(e) {
        promptMsg.ShowPromptMsg("uexCamera不存在");
        logs("uexCamera不存在");
    }
}

function pickImg(key, obj) {
    try {
        var data = {
            min : 1,
            max : 1,
            quality : 0.5,
            detailedInfo : true
        };
        uexImage.openPicker(data, function(error, info) {
            if (error == 0) {
                if (info.detailedImageInfo) {
                    writePic(info.detailedImageInfo[0].localPath, key, obj);
                }
            } else {
                //不选择图片，返回，不应提示错误
                //promptMsg.ShowPromptMsg("选择图片时出现错误，请稍候重试");
            }
        });

    } catch(e) {
        promptMsg.ShowPromptMsg("uexImageBrower或uexImage不存在");
    }
}

var imgLocalPath = new Array();
var maxImgaeLength = 1048576;

//选择图片后，加载在页面上
function writePic(imgInfo, key, obj) {
    var arrData = new Array();
    if ( imgInfo instanceof Array) {
        arrData = imgInfo;
    } else {
        arrData.push(imgInfo);
    }
    var addCount = arrData.length;
    if (imgLocalPath.length + addCount > pictureMax) {
        warningMsg.ShowPromptMsg("最多允许上传" + pictureMax + "个附件！");
        return;
    }
   // alert(arrData[0]);
   logs("arrData[0]："+arrData[0]);
    // var file = uexFileMgr.open({
        // path : imgInfo,
        // mode : 3
    // });
    // logs("file1111："+file);
    // var size = uexFileMgr.getFileSize(file);
    // logs("size1111："+size);
    // if (size > maxImgaeLength) {
        // warningMsg.ShowPromptMsg("附件大小超出最大允许的1M");
        // return;
    // }
    var iindex = imgLocalPath.length;
    logs("iindex-begin:" + iindex);
    for (var i in arrData) {
        var mdl = {
            "src" : arrData[i],
            "baseCode" : ""
        };
        imgLocalPath.push(mdl);
    }
    logs("iindex-end:" + imgLocalPath.length);
    logs("pushend");
    logs("imgLocalPath："+imgLocalPath[0]);
    for (var i in arrData) {
        MyreadFile(arrData[i], key, Cb_ConvertImg, parseInt(i) + parseInt(iindex), obj);
    }
}

function Cb_ConvertImg(data, MyfilePath, key, mindex, obj) {
    imgLocalPath[mindex].baseCode = data;
    var mlength = parseInt(imgLocalPath.length) - 1;
    if (mindex == mlength) {
        try {
            var ihtml = GetFileShowHtml(key, imgLocalPath);
            $(obj).prev("div").html(ihtml);
        } catch(ex) {
            logs("error:" + ex.message);
        }
    }
}

/**
 * 读文件
 */
function MyreadFile(MyfilePath, key, cb, mindex, obj) {
    var file = uexFileMgr.open({path: MyfilePath,mode: 1});
    if(file){
        uexFileMgr.readFile(file,-1,1,function(error,data){
            if(error == 0){
                cb(data, MyfilePath, key, mindex, obj);
                uexFileMgr.closeFile(file);
            }
        });
    }
}

function GetFileShowHtml(key, data) {
    var deleteBtn = '<div class="fa fa-times inline" style="margin-left:.1rem;color:#E0E0E0"></div>';
    var ihtml = "";
    if (data && data.length > 0) {
        ihtml += "<div class='ub' style='width:100%;float:left;'>";
        for (var i in data) {
            ihtml += "<div class='ub' style='margin-top:0rem;margin-right:.2rem;'>";
            ihtml += "<div class='ub' style='width:calc(1.6rem);height:calc(1.6rem);overflow: hidden;'>";
            ihtml += "<img name='imgUp' src=" + data[i].src + " onclick='ImgBrowser(this)' class='selectedItem fjimg'/>";
            ihtml += "</div>";
            ihtml += '<div name="imgdel" class="imgdel" onclick="delImg(\'' + key + '\',this);"></div>';
            ihtml += "</div>";
        }
        ihtml += "</div>";
    }
    return ihtml;
}

//点击图片浏览
function ImgBrowser(img) {
    var paths = [];
    $.each($("img[name=imgUp]"), function(i, obj) {
        paths.push({
            src : $(obj).attr("src"),
            thumb : "",
            desc : ""
        });
    });
    var index = $("img[name=imgUp]").index($(img));
    try {
        var data = {
            displayActionButton : false,
            displayNavArrows : true,
            enableGrid : true,
            startIndex : index,
            data : paths
        }
        var json = JSON.stringify(data);
        uexImage.openBrowser(json);
    } catch(e) {
        promptMsg.ShowPromptMsg("图片不能浏览");
        //alert("图片不能浏览");
    }
}

//删除上传的图片
function delImg(key, img) {
    var src = $(img).prev().find(".fjimg").attr("src");
    //从imgLocalPath中移除
    for (var k in imgLocalPath) {
        if (imgLocalPath[k].src == src) {
            imgLocalPath.splice(k, 1);
            break;
        }
    }
    //setLocVal(key + "_Items",jsonToStr(imgLocalPath));
    $(img).parent().remove();
}

//===========2017-7-20 增加明细表填写============//
//给明细表赋值
function GetModifyDetailData(RequestInfo, ismustcheck) {
    var result = true;
    var TableRecord = JSON.parse(tmplTableRecord);
    var rows = {};
    rows.WorkflowRequestTableRecord = [];
    var tableList = $("#DetailList .GroupLine");
    $.each($(tableList), function(m, lineObj) {
        var row = {};
        row.WorkflowRequestTableField = [];
        var datas = $(lineObj).find("[data-Index]");
        try {
            for (var i = 0; i < datas.length; i++) {
                //获取模板
                var TableField = TableRecord.workflowRequestTableFields.WorkflowRequestTableField[i];
                var tempTableField = JSON.parse(jsonToStr(TableField));
                /*值索引*/
                var dataIndex = $(datas[i]).attr("data-Index");
                var index = dataIndex.substring(dataIndex.indexOf("c") + 1, dataIndex.length);
                /*取值类型*/
                var type = $(datas[i]).attr("valuetype");
                var getValue = "";
                var getText = "";
                switch(type) {
                case "select":
                    var selelindex = $(datas[i])[0].selectedIndex;
                    getValue = $(datas[i])[0].options[selelindex].value;
                    getText = $(datas[i])[0].options[selelindex].text;
                    break;
                case "text":
                    var obj = $(datas[i]);
                    getValue = obj.val();
                    getText = obj.val();
                    break;
                case "textarea":
                    var obj = $(datas[i]);
                    getValue = obj.val();
                    getText = obj.val();
                    break;
                case "check":
                    var obj = $(datas[i]);
                    getValue = obj.is(":checked") ? "1" : "0";
                    getText = obj.is(":checked") ? "是" : "否";
                    break;
                case "Department":
                    var obj = $(datas[i]);
                    var filename = obj.attr("filedname");
                    var filedvalue = strToJson(getLocVal(filename + "_Items"));
                    for (var j in filedvalue) {
                        getText += filedvalue[j].itemName + " ";
                        getValue += filedvalue[j].itemID + ",";
                    }
                    if (getText != "") {
                        getText = getText.substr(0, getText.length - 1);
                    }
                    if (getValue != "") {
                        getValue = getValue.substr(0, getValue.length - 1);
                    }
                    break;
                case "Image":
                    var obj = $(datas[i]);
                    var filename = obj.attr("filedname");
                    if (imgLocalPath.length > 0) {
                        var filedvalue = imgLocalPath;
                        var filedType = "";
                        var m = 0;
                        for (var j in filedvalue) {
                            m++;
                            getText = "附件";
                            filedType += "base64:附件" + m + ".jpg|";
                            getValue += filedvalue[j].baseCode + "|";
                            //baseCode是base64转码后的值
                        }
                        tempTableField.fieldType = filedType;
                    }
                    break;
                case "lable":
                    var obj = $(datas[i]);
                    getValue = obj.attr("fieldValue");
                    getText = obj.html();
                    break;
                default:
                    break;
                }
                getText = DealString(getText);
                getValue = DealString(getValue);
                if (ismustcheck) {
                    if (TableField.mand == true) {
                        var name = TableField.fieldShowName;
                        switch(type) {
                        case "select":
                            if (getText == "（必填项）") {
                                warningMsg.ShowPromptMsg("请选择" + name);
                                result = false;
                                return false;
                            }
                            break;
                        case "text":
                            if (getText == "") {
                                warningMsg.ShowPromptMsg("请输入" + name);
                                result = false;
                                return false;
                            }
                            break;
                        case "textarea":
                            if (getText == "") {
                                warningMsg.ShowPromptMsg("请输入" + name);
                                result = false;
                                return false;
                            }
                            break;
                        case "Department":
                            if (getText == "") {
                                warningMsg.ShowPromptMsg("请选择" + name);
                                result = false;
                                return false;
                            }
                            break;
                        default:
                            break;
                        }
                    }
                }
                tempTableField.edit = true;
                tempTableField.fieldValue = getValue;
                tempTableField.fieldShowValue = getText;
                tempTableField.fieldOrder = m.toString();
                tempTableField.fieldFormName = "field" + tempTableField.fieldId + "_" + m.toString();
                row.WorkflowRequestTableField.push(tempTableField);
            }
            var orderrow = {};
            orderrow.recordOrder = [];
            orderrow.recordOrder = m.toString();
            orderrow.workflowRequestTableFields = [];
            orderrow.workflowRequestTableFields = row;
            rows.WorkflowRequestTableRecord.push(orderrow);
        } catch(ex) {
            logs("error:" + ex.message);
        }
    });
    if (result) {
        if (rows.WorkflowRequestTableRecord.length == 0) {
            rows = "";
        }
        RequestInfo.workflowDetailTableInfos.WorkflowDetailTableInfo[0].workflowRequestTableRecords = rows;
    }
    return result;
}

//给明细表添加一行
function AddDetailRow(obj, Detailobject, ConfigModelTableField) {
    var objDiv = $(obj).parents("#DetailInfoDiv").find("#DetailInfo");
    var rowNo = objDiv.children().length;
    var dhtml = GetDetailRowHtml(rowNo, Detailobject, ConfigModelTableField);
    objDiv.append(dhtml);

    var height = objDiv.scrollHeight;
    objDiv.css("height", height);
    objDiv.css("height", "auto");
    objDiv.addClass("show");
    objDiv.prev().find("span").html('收起 ');
    objDiv.prev().find(".imgchange").removeClass("imgDivShow");
    objDiv.prev().find(".imgchange").addClass("imgDivHide");
    event.stopPropagation();
}

//删除明细表的某一行
function DeleteDetailRow(obj) {
    new SinochemConfirmationMsg("", function() {
        //其他行的序号变更
        var rowList = $(obj).parents("#DetailInfo");
        //移除本行
        $(obj).parent().parent().parent().remove();
        $.each($(rowList).children(), function(index, obj) {
            $(obj).find(".LineTitleDiv b").text(parseInt(index) + 1);
        });
    }, 2).ShowConfirmationMsg("", "确定要删除吗？");
    event.stopPropagation();
}

//生成明细表的行
function GetDetailRowHtml(rowNo, Detailobject, ConfigModelTableField) {
    var dhtml = "";
    //Detailobject = data.data.workflowDetailTableInfos[0].WorkflowDetailTableInfo[t].workflowRequestTableRecords[0].WorkflowRequestTableRecord;
    for (var j in Detailobject) {
        dhtml += "<div class='ub ub-ver LineDiv' style='margin-bottom:0'>";
        dhtml += "<div class='ub LineValue LineTitleDiv' style='background-color:#F4F4F4'>";
        dhtml += '     <div class="ub ub-ac ub-f1 LineTitle blackFont">';
        dhtml += '        <div>序号<b>' + (parseInt(rowNo) + 1) + '</b></div>';
        dhtml += '        <div class="imgDelete sicon-size ub-img5" onclick="DeleteDetailRow(this)"></div>';
        dhtml += '    </div>';
        dhtml += "    <div class='ub' onclick='expandLine(this)'>";
        dhtml += '        <div class="ub uc-a ub-ac ExpandDivDetail">';
        dhtml += '            <span>收起</span><div class="imgchange imgDivHide2 sicon-size ub-img5"></div>';
        dhtml += '        </div>';
        dhtml += '    </div>';
        dhtml += "</div>";
        dhtml += "<div class='ub ub-ver GroupLine'>";
        var fields = Detailobject[j].workflowRequestTableFields.WorkflowRequestTableField;
        for (var k in fields) {
            var obj = fields[k];
            var isShowBase = false;
            var isShowFile = false;
            var isHidden = false;
            var IsReadonly = false;
            /*标识是否为强制显示*/
            var isMyshow = false;
            var showname = "";
            showname = obj.fieldShowName;
            for (var j in ConfigModelTableField) {
                var mdl = ConfigModelTableField[j];
                if (mdl.FieldCode == obj.fieldName) {
                    isShowBase = mdl.IsBaseInfo == "Y" ? true : false;
                    isShowFile = mdl.IsFileInfo == "Y" ? true : false;
                    isHidden = mdl.IsHidden == "Y" ? true : false;
                    IsReadonly = mdl.IsReadonly == "Y" ? true : false;
                    isMyshow = mdl.IsHidden == "S" ? true : false;
                    showname = mdl.FieldName;
                    obj.fieldShowName = showname;
                    break;
                }
            }
            if (isHidden || obj.view == false) {
                dhtml += "<div class='ub LineValue uhide'>";
            } else {
                dhtml += "<div class='ub LineValue'>";
            }
            dhtml += "   <div class='tx-r grayFont LineShowTitle'>" + showname + "</div>";
            obj.edit = true;
            dhtml += GetShowHtml(obj, "r" + rowNo.toString() + "c" + k.toString(), true, false);
            dhtml += "</div>";
        }
        dhtml += "</div>";
        dhtml += "</div>";
    }
    return dhtml;
}

//纠正报文中的错误格式的数据
function CorrectData(data) {
    var str = jsonToStr(data);
    if (str != "") {
        var str = str.replace(/{"attributes":{"xsi:nil":"true"}}/g, '""');
    }
    return strToJson(str);
}

function checkLeaveReslut(RequestInfo,cb) {
    var CallData = {
        "requestInfo" : jsonToStr(RequestInfo),
        "email":getLocVal("email"),
        "orgCode":getLocVal("OrgCode")
    };
    callAjaxService("POST", "checkLeaveReslut", CallData, true, function(data) {
       if (data.status == "0") {
            cb();
        } else {
            promptMsg.ShowPromptMsg(data.msg);
            setTimeout(function() {
                var btnarry = [{
                    "id" : "btnAgree",
                    "classname" : "btnAgree"
                }];
                SetPageY(btnarry, BindClick);
                promptMsg.HideMsg();
            }, 3000);
            return;
        }
    });
}

function checkAwayReslut(RequestInfo,cb) {
    var CallData = {
        "requestInfo" : jsonToStr(RequestInfo),
        "email":getLocVal("email"),
        "orgCode":getLocVal("OrgCode")
    };
    callAjaxService("POST", "checkAwayReslut", CallData, true, function(data) {
       if (data.status == "0") {
            cb();
        } else {
            promptMsg.ShowPromptMsg(data.msg);
            setTimeout(function() {
                var btnarry = [{
                    "id" : "btnAgree",
                    "classname" : "btnAgree"
                }];
                SetPageY(btnarry, BindClick);
                promptMsg.HideMsg();
            }, 3000);
            return;
        }
    });
}
