(function(w) {
    w.BalanceOrder = function(params) {
        this.TenantID = "";
        this.CallBack = function(result) {
        };
        this.LType = "L044";
        this.BalanceID = "";
        this.RootTenantID = "";
        this.UserName = "";
        this.NoticeMsg = new SinochemPromptMsg("N", 3000);
        for (var key in params) {
            this[key] = params[key];
        }
    }
    $.extend(w.BalanceOrder.prototype, {
        BalanceOrderCall : function(CallData, functionName, needCallBack, extraFun, errFun) {
            var thisObj = this;
            callAjaxService("POST", functionName, CallData, true, function(result) {
                if (result.ResultCode == "0") {
                    if (extraFun) {
                        extraFun(result);
                    }
                    if (needCallBack) {
                        thisObj.CallBack(result);
                    }
                } else {
                    thisObj.NoticeMsg.ShowPromptMsg(result.ResultMsg);
                }
            }, function(result) {
                if (errFun) {
                    errFun();
                }
            });
        },
        GetBalanceOrderDetail : function() {
            var CallData = {
                LType : this.LType,
                StrOptions : {
                    TenantID : this.TenantID,
                    sPid : this.BalanceID
                }
            };
            this.BalanceOrderCall(CallData, "QueryList", true, function(result) {
                formatData(result);
            });
        },
        GetBalanceRelativeDataList : function(itemType, itemID, spID) {
            if (!itemType || itemType == "") {
                this.NoticeMsg.ShowPromptMsg("参数itemType必传");
                return;
            }
            if (!itemID || itemID == "") {
                this.NoticeMsg.ShowPromptMsg("参数itemID必传");
                return;
            }
            if (!spID || spID == "") {
                this.NoticeMsg.ShowPromptMsg("参数spID必传");
                return;
            }
            var CallData = {
                LType : this.LType,
                StrOptions : {
                    TenantID : this.TenantID,
                    RootTenantID : this.RootTenantID,
                    spid : spID,
                    sPSItemid : itemID
                }
            };
            CallData.StrOptions[((itemType == "GT03" || itemType == "GT04") ? "sGroupType" : "sPItemType")] = itemType;
            this.BalanceOrderCall(CallData, "QueryList", true, function(result) {
                formatData(result);
            });
        },
        ConfirmBalanceOrder : function(feedback, processMode, psID, cb) {
            if (!feedback || feedback == "") {
                this.NoticeMsg.ShowPromptMsg("参数feedback必传");
                return;
            }
            if (!processMode || processMode == "") {
                this.NoticeMsg.ShowPromptMsg("参数processMode必传");
                return;
            }
            if (!psID || psID == "") {
                this.NoticeMsg.ShowPromptMsg("参数psID必传");
                return;
            }

            var CallData = {
                StrOptions : {
                    TenantID : this.TenantID,
                    RootTenantID : this.RootTenantID,
                    sPSID : psID,
                    sFeedbackResult : feedback,
                    sFeedbackDesc : "",
                    sProcessMode : processMode,
                    sBankNo : "",
                    sBankName : "",
                    sAccName : "",
                    sAccNo : "",
                    UserName : this.UserName
                }
            };
            this.BalanceOrderCall(CallData, "ConfirmPSBill", false, function(result) {
                if (cb) {
                    cb(result);
                }
            });
        }
    });

    w.BalanceOrderList = function(params) {
        BalanceOrder.call(this, {});
        this.LType = "L045";
        this.CurrentPageIndex = 1;
        this.PageSize = 10;
        this.sQueryMode = "QT0907";
        var datetime = new Date();
        var year = datetime.getFullYear().toString();
        var month = (datetime.getMonth() + 1).toString();
        var day = datetime.getDate().toString();
        this.DefaultEndTime = year + "-" + (month.length > 1 ? month : "0" + month) + "-" + (day.length > 1 ? day : "0" + day);
        for (var key in params) {
            this[key] = params[key];
        }
    }
    BalanceOrderList.prototype = new BalanceOrder();
    $.extend(BalanceOrderList.prototype, {
        GetBalanceOrderList : function(endTime) {
            if (!endTime || endTime == "") {
                endTime = this.DefaultEndTime;
            }
            var CallData = {
                LType : this.LType,
                StrOptions : {
                    StartTime : "",
                    EndTime : "", //endTime
                    PageIndex : this.CurrentPageIndex,
                    PageSize : this.PageSize,
                    CompanyName : "",
                    sQueryMode : this.sQueryMode,
                    TenantID : this.TenantID,
                }
            };

            this.BalanceOrderCall(CallData, "QueryList", true, function(result) {
                var dataItems = result.Data.Items;
                for (var i in dataItems) {
                    var item = dataItems[i];
                    formatData(item);
                    switch(item.PSState) {
                    case "PS00":
                        item.PSStateName = "新建";
                        break;
                    case "PS01":
                        item.PSStateName = "草稿";
                        break;
                    case "PS10":
                        item.PSStateName = "发布中";
                        break;
                    case "PS11":
                        item.PSStateName = "协商中";
                        break;
                    case "PS12":
                        item.PSStateName = "协商完毕";
                        break;
                    case "PS90":
                        item.PSStateName = "结算完成";
                        break;
                    case "PS91":
                        item.PSStateName = "作废";
                        break;
                    }
                }
            });
        },
        ReLoadData : function() {
            this.CurrentPageIndex = 1;
            this.GetBalanceOrderList();
        },
        LoadNextData : function() {++this.CurrentPageIndex;
            this.GetBalanceOrderList();
        },
        ResetOrderStateName : function(psID) {
            $("[psID=" + psID + "]").find("[name=balanceState]").text("协商完毕");
        }
    });

    w.BalanceRDDetialList = function(params) {
        BalanceOrder.call(this, {});
        this.LType = "L050";
        this.CurrentPageIndex = 1;
        this.PageSize = 10;
        this.LineID = "";
        this.PSID = "";
        for (var key in params) {
            this[key] = params[key];
        }
    }
    BalanceRDDetialList.prototype = new BalanceOrder();
    $.extend(BalanceRDDetialList.prototype, {
        GetBalanceRDDetialList : function() {
            var CallData = {
                LType : this.LType,
                StrOptions : {
                    TenantID : this.TenantID,
                    RootTenantID : this.RootTenantID,
                    spid : this.PSID,
                    sLineParantID : this.LineID,
                    PageIndex : this.CurrentPageIndex,
                    PageSize : this.PageSize
                }
            };
            this.BalanceOrderCall(CallData, "QueryList", true, function(result) {
                formatData(result);
            });
        },
        ReLoadData : function() {
            this.CurrentPageIndex = 1;
            this.GetBalanceRDDetialList();
        },
        LoadNextData : function() {++this.CurrentPageIndex;
            this.GetBalanceRDDetialList();
        }
    });

    function formatData(data) {
        for (var key in data) {
            if ( typeof (data[key]) == "object") {
                formatData(data[key]);
            }
            if (data[key] || data[key] == 0) {
                switch(key) {
                case "StartDate":
                case "EndDate":
                case "RecentEndDate":
                case "Ref_BizDate":
                    var value = data[key].toString();
                    if (value != "0") {
                        data[key] = value.substr(0, 4) + "-" + value.substr(4, 2) + "-" + value.substr(6, 2);
                    } else {
                        data[key] = "";
                    }
                    break;
                case "MStampTime":
                case "CreatedAt":
                    data[key] = data[key].substr(0, 10);
                    break;
                }

                if (key.indexOf("Amount") >= 0) {
                    data[key] = commafy(data[key].toFixed(2));
                }
                if (key.indexOf("Price") >= 0) {
                    data[key] = commafy(data[key].toFixed(6));
                }
                if (key.indexOf("Quantity") >= 0) {
                    data[key] = commafy(data[key].toFixed(3));
                }
            }
        }
    }

})(window)
