(function(window) {
    window.Message = function(params) {
        this.StrOptions = null;
        this.TenantID = "";
        this.CallBack = function(result) {
        };
        this.ErrorBack = function() {
        };
        for (var key in params) {
            this[key] = params[key];
        }
    }
    $.extend(Message.prototype, {
        MessageCall : function(CallData, functionName, needCallBack, extraFun) {
            var msgObj = this;
            callAjaxService("POST", functionName, CallData, true, function(result) {
                if (result.ResultCode == "0") {
                    if (result.Data && result.Data.Items && result.Data.Items == null) {
                        result.Data.Items = [];
                    }
                    if (extraFun) {
                        extraFun(result);
                    }
                    if (needCallBack) {
                        msgObj.CallBack(result);
                    }
                } else {
                    noticeMsg = new SinochemPromptMsg("N", 3000);
                    noticeMsg.ShowPromptMsg(result.ResultMsg);
                }
                if (msgListObj.CurrentPageIndex == 1) {
                    resetBV(0);
                } else {
                    resetBV(1);
                }
            }, function(result) {
                if (msgListObj.CurrentPageIndex == 1) {
                  resetBV(0);
                } else {
                    resetBV(1);
                }
                loadingMsg.HideMsg();
                msgObj.ErrorBack();
            });
        },
        SetMessageRead : function(messageID) {
            noticeMsg = new SinochemPromptMsg("N", 3000);
            if (this.TenantID == "") {
                noticeMsg.ShowPromptMsg("参数TenantID必传");
                return;
            }
            if (messageID && messageID == "") {
                noticeMsg.ShowPromptMsg("参数MessageID必传");
                return;
            }
            if (this.StrOptions == null) {
                noticeMsg.ShowPromptMsg("参数StrOptions必传");
                return;
            }
            this.StrOptions.Result = "02"
            var CallData = {
                TenantID : this.TenantID,
                MessageID : messageID,
                StrOptions : this.StrOptions
            };
            //this.MessageCall(CallData, "ProcessMsg", false);
            callAjaxService("POST", "ProcessMsg", CallData, false)
        }
    });

    /***********************消息列表********************************/
    window.MessageList = function(params) {
        Message.call(this, {});
        this.LType = "L123";
        this.CurrentPageIndex = 1;
        this.PageSize = 10;
        for (var key in params) {
            this[key] = params[key];
        }
    }
    MessageList.prototype = new Message();
    $.extend(MessageList.prototype, {
        GetMessageList : function(requirements, processObj) {
            loadingMsg.ShowLoadingMsg("数据加载中...");
            if (this.StrOptions == null) {
                noticeMsg = new SinochemPromptMsg("N", 3000);
                noticeMsg.ShowPromptMsg("参数StrOptions必传");
                return;
            }

            this.StrOptions["PageSize"] = this.PageSize;
            this.StrOptions["PageIndex"] = this.CurrentPageIndex;
            this.StrOptions["QueryMode"] = "QT0216";
            this.StrOptions["TimeType"] = TimeType;
            if (requirements) {
                for (var key in requirements) {
                    this.StrOptions[key] = requirements[key];
                }
            }

            var CallData = {
                LType : this.LType,
                TenantID : getLocVal("CurrentTenantID"),
                QueryMode : "QT0216",
                SceneCode : this.StrOptions["MsgCategory"],
                StrOptions : this.StrOptions
            };

            var msgObj = this;
            this.MessageCall(CallData, "QueryList", true, function(result) {
                result.PageIndex = msgObj.StrOptions.PageIndex;
                if (processObj) {
                    result.ProcessObj = processObj;
                }
            });
        },
        GetMessageIsNewStorage : function(userCode) {
            var msgIsNewStorage = {};
            if (getLocVal(userCode + "MsgIsNew") != "") {
                msgIsNewStorage = JSON.parse(getLocVal(userCode + "MsgIsNew"));
            }
            return msgIsNewStorage;
        },
        SetMessageIsNewStorage : function(userCode, msgIsNewStorage) {
            setLocVal(userCode + "MsgIsNew", JSON.stringify(msgIsNewStorage));
        },
        ReLoadData : function() {
            this.CurrentPageIndex = 1;
            this.GetMessageList({
                PageIndex : this.CurrentPageIndex
            });
        },
        LoadNextData : function() {
            this.GetMessageList({
                PageIndex : ++this.CurrentPageIndex
            });
        }
    });

    /***********************消息类型********************************/
    window.MessageTypeList = function(params) {
        Message.call(this, {});
        this.msgTypeImgCssConfig = {
            "MC08" : "dConsultingImg",
            "MC07" : "dDealImg",
            "MC09" : "dExecutingImg",
            "MC01" : "dEntryImg",
            "MC10" : "dSourceImg",
            "MC06" : "dInvitingImg",
            "MC04" : "dApplicationImg",
            "MC02" : "dQuoteImg",
            "MC03" : "dInquiryImg",
            "BT01" : "icon_daiban",
            "BT02" : "icon_tongzhi",
            "" : "dSendOutImg",
        };
        for (var key in params) {
            this[key] = params[key];
        }
    }
    MessageTypeList.prototype = new Message();
    $.extend(MessageTypeList.prototype, {
        GetMessageTypeList : function() {
            if (this.TenantID == "") {
                noticeMsg = new SinochemPromptMsg("N", 3000);
                noticeMsg.ShowPromptMsg("参数TenantID必传");
                return;
            }
            var CallData = {
                TenantID : this.TenantID,
                StrOptions : {}
            };
            loadingMsg.ShowLoadingMsg("数据加载中...");
            this.MessageCall(CallData, "MsgCategoryByUserCode", true);
        },
        GetMessageTypeListNew : function() {
            if (this.TenantID == "") {
                noticeMsg = new SinochemPromptMsg("N", 3000);
                noticeMsg.ShowPromptMsg("参数TenantID必传");
                return;
            }
            var CallData = {
                LType : "L124",
                StrOptions : {
                    "PageIndex" : "1",
                    "PageSize" : "10",
                    "DirectType" : "IN",
                    "MsgCategory" : "MC06",
                    "TenantID" : this.TenantID
                }
            };
            loadingMsg.ShowLoadingMsg("数据加载中...");
            this.MessageCall(CallData, "QueryList", true);
        }
    });
})(window)
