(function(window) {
    window.Order = function(params) {
        this.StrOptions = null;
        this.OrderID = "";
        this.TenantID = "";
        this.DType = "D004";
        this.Ref_TenantID = "";
        this.OrderTenantID = "";
        this.OrderDetails = null;
        this.CallBack = function() {
        };
        for (var key in params) {
            this[key] = params[key];
        }
    }
    $.extend(Order.prototype, {
        OrderCall : function(CallData, functionName, needCallBack, extraFun) {
            var thisObj = this;
            callAjaxService("POST", functionName, CallData, true, function(result) {
                if (result.ResultCode == "0") {
                    if (result.Data && result.Data.Items && result.Data.Items == null) {
                        result.Data.Items = [];
                    }
                    // if ( typeof (result.Data) == "string") {
                    // result.Data = JSON.parse(result.Data);
                    // }

                    if (extraFun) {
                        extraFun(thisObj, result);
                    }
                    if (needCallBack) {
                        thisObj.CallBack(result);
                    }
                } else {
                    noticeMsg = new SinochemPromptMsg("N", 3000);
                    noticeMsg.ShowPromptMsg(result.ResultMsg);
                }
            }, function(result) {
                noticeMsg = new SinochemPromptMsg("N", 3000);
                noticeMsg.ShowPromptMsg(loadFailMsg);
            });
        },
        GetSaleOrderDetail : function() {
            noticeMsg = new SinochemPromptMsg("N", 3000);
            if (this.OrderID == "") {
                noticeMsg.ShowPromptMsg("参数OrderID必传");
                return;
            }
            if (this.TenantID == "") {
                noticeMsg.ShowPromptMsg("参数TenantID必传");
                return;
            }
            var CallData = {
                DType : this.DType,
                DID : this.OrderID,
                StrOptions : {
                    sTenantID : this.Ref_TenantID == "" ? this.TenantID : this.Ref_TenantID,
                    TenantID : this.TenantID
                }
            };
            this.OrderCall(CallData, "QueryDetail", true, function(thisObj, result) {
                thisObj.OrderDetails = result.Data.Details;
                var dataHeader = result.Data.Header;
                if (dataHeader.BizTime && dataHeader.BizTime != "") {
                    dataHeader.BizTime = dataHeader.BizTime.replace("T", " ").replace(/\..+/g, "");
                    dataHeader.BizTime = dataHeader.BizTime.replace("00:00:00", "");
                }
                dataHeader.OrderMtrlQty = dataHeader.MtrlQty;
                thisObj.OrderTenantID = dataHeader.TenantID;
                formatData(result);
            });
        },
        ConfirmOrder : function(cb, errcb) {
            var CallData = {
                StrOptions : {
                    TenantID : this.TenantID,
                    OrderID : this.OrderID
                }
            };

            this.OrderCall(CallData, "ConfirmOrder", false, function(thisObj, result) {
                if (cb) {
                    cb(result);
                }
            }, errcb);
        },
        ConfrimExecuteOrder : function(cb, errcb) {
            var CallData = {
                StrOptions : {
                    TenantID : this.TenantID,
                    OrderID : this.OrderID
                }
            };

            this.OrderCall(CallData, "ConfrimExecuteOrder", false, function(thisObj, result) {
                if (cb) {
                    cb(result);
                }
            }, errcb);
        },
        SetOrderPayMode : function(payMode, cb, errcb) {
            var CallData = {
                StrOptions : {
                    TenantID : this.OrderTenantID, //买家的TenantID
                    OrderID : this.OrderID
                }
            };

            if (!payMode || payMode == "") {
                noticeMsg.ShowPromptMsg("参数payMode必传");
                return;
            }

            CallData.StrOptions.PayMode = payMode;

            this.OrderCall(CallData, "SetOrderPayMode", false, function(thisObj, result) {
                if (cb) {
                    cb(result);
                }
            }, errcb);
        }
    });

    function formatData(data) {
        for (var key in data) {
            if ( typeof (data[key]) == "object") {
                formatData(data[key]);
            }

            //数量格式
            var quantityFilter = "|OrderMtrlQty|MtrlQty|";
            if (quantityFilter.indexOf("|" + key + "|") >= 0) {
                if ( typeof (data[key]) == "number") {
                    data[key] = data[key].toFixed(3);
                }
            }

            if ( typeof (data[key]) == "number") {
                data[key] = commafy(data[key].toFixed(2));
            }

            if (!data[key] || data[key] == "") {
                switch(key) {
                case "ThumbnailURL":
                    data[key] = "css/images/default.png";
                    break;
                }
            } else {
                switch(key) {
                case "ResType":
                    if (data[key] == "RT0201") {
                        data.ResTypeImage = "css/images/frowardGoods.png";
                    } else {
                        data.ResTypeImage = "css/images/spotGoods.png";
                    }
                    break;
                }
            }
        }

    }

})(window)
