(function(w) {
    noticeMsg = new SinochemPromptMsg("N", 3000);
    w.OrderDraft = function(params) {
        this.StrOptions = null;
        this.OrderID = "";
        this.OrderTenantID = "";
        this.TenantID = "";
        this.UserName = "";
        this.CallBack = function() {
        };
        for (var key in params) {
            this[key] = params[key];
        }
    }
    $.extend(OrderDraft.prototype, {
        DraftCall : function(CallData, functionName, needCallBack, extraFun, errFun) {
            var thisObj = this;
            callAjaxService("POST", functionName, CallData, true, function(result) {
                if (result.ResultCode == "0") {
                    if (result.Data && result.Data.Items && result.Data.Items == null) {
                        result.Data.Items = [];
                    }
                    if (extraFun) {
                        extraFun(thisObj, result);
                    }
                    if (needCallBack) {
                        thisObj.CallBack(result);
                    }
                } else {
                    noticeMsg.ShowPromptMsg(result.ResultMsg);
                    if (errFun) {
                        errFun();
                    }
                }
            }, function(result) {
                noticeMsg.ShowPromptMsg(loadFailMsg);
                if (errorFun) {
                    errorFun();
                }
            });
        },
        DeleteOrder : function(cb) {
            var CallData = {
                StrOptions : {
                    orderID : this.OrderID,
                    RootTenantID : this.TenantID,
                    TenantID : this.OrderTenantID
                }
            };
            this.DraftCall(CallData, "DeleteOrderByID", false, function(thisObj, result) {
                if (cb) {
                    cb();
                }
            });
        },
        GetDefaultAddress : function(cb) {
            var CallData = {
                LType : "L041",
                StrOptions : {
                    AddressType : "EP",
                    TenantID : this.TenantID
                }
            }
            this.DraftCall(CallData, "QueryList", false, function(thisObj, result) {
                if (cb) {
                    cb(result);
                }
            });
        },
        SubmitOrder : function(wlFlag, payMode, sSoPSPlans, cb) {
            var commonSoPSPlan = {
                BillID : "",
                Memo : "",
                PerName : "",
                PerTel : "",
                FeePrice : 0,
                ShipToMemo : "",
                ShipToPerID : "",
                ShipToPerIDType : "",
                ShipToPerMTel : "",
                TransMode : "",
                SubmitTime : "",
                TransTime : "",
                OrderID : this.OrderID,
            };
            var CallData = {
                StrOptions : {
                    UserName : this.UserName,
                    RootTenantID : this.TenantID,
                    TenantID : this.OrderTenantID,
                    OrderID : this.OrderID,
                },
                sSoPSPlans : new Array()
            }

            // if (!wlFlag || wlFlag == "") {
                // noticeMsg.ShowPromptMsg("参数wlFlag必传");
                // return;
            // }
            // if (!payMode || payMode == "") {
                // noticeMsg.ShowPromptMsg("参数payMode必传");
                // return;
            // }
            // if (!sSoPSPlans || sSoPSPlans == "") {
                // noticeMsg.ShowPromptMsg("参数sSoPSPlans必传");
                // return;
            // }
            CallData.StrOptions.WLFlag = wlFlag;
            CallData.StrOptions.PayMode = payMode;
            for (var i in sSoPSPlans) {
                CallData.sSoPSPlans.push(commonSoPSPlan);
                for (var key in sSoPSPlans[i]) {
                    CallData.sSoPSPlans[i][key] = sSoPSPlans[i][key];
                }
            }
            CallData.sSoPSPlans = JSON.stringify(sSoPSPlans);
            this.DraftCall(CallData, "SubmitOrder", false, function(thisObj, result) {
                if (cb) {
                    cb(result);
                }
            });
        }
    });
})(window)
