(function(w) {
    w.ReturnGoodsList = function(params) {
        this.TenantID = "";
        this.CallBack = function(result) {
        };
        this.CurrentPageIndex = 1;
        this.PageSize = 10;
        this.NoticeMsg = new SinochemPromptMsg("N", 3000);
        for (var key in params) {
            this[key] = params[key];
        }
    }

    $.extend(ReturnGoodsList.prototype, {
        ListCall : function(CallData, functionName, needCallBack, extraFun, errFun) {
            var thisObj = this;
            callAjaxService("POST", functionName, CallData, true, function(result) {
                if (result.ResultCode == "0") {
                    if (extraFun) {
                        extraFun(result);
                    }
                    if (needCallBack) {
                        thisObj.CallBack(result);
                    }
                } else {
                    thisObj.NoticeMsg.ShowPromptMsg(result.ResultMsg);
                }
            }, function(result) {
                if (errFun) {
                    errFun();
                }
            });
        }
    });

    w.ReturnGoodsCompanyList = function(params) {
        ReturnGoodsList.call(this, {});
        this.LType = "L053";
        for (var key in params) {
            this[key] = params[key];
        }
    }
    ReturnGoodsCompanyList.prototype = new ReturnGoodsList();
    $.extend(ReturnGoodsCompanyList.prototype, {
        GetList : function() {
            var CallData = {
                LType : this.LType,
                StrOptions : {
                    TenantID : this.TenantID,
                    PageIndex : this.CurrentPageIndex,
                    PageSize : this.PageSize,
                    TopIndex : 1,
                    QueryValue : ""
                }
            };
            this.ListCall(CallData, "QueryList", true, function(result) {
                var dataItems = result.Data.Items;
                for (var i in dataItems) {
                    if (dataItems[i].Notices && dataItems[i].Notices.length > 0) {
                        dataItems[i].NoticeNo = dataItems[i].Notices[0].NoticeNo;
                        dataItems[i].NoticeState = dataItems[i].Notices[0].NoticeState;
                        dataItems[i].ExpressCompany = dataItems[i].Notices[0].ExpressCompany;
                        dataItems[i].ExpressNo = dataItems[i].Notices[0].ExpressNo;
                        if (dataItems[i].Notices[0].BizTime) {
                            dataItems[i].BizTime = dataItems[i].Notices[0].BizTime.split('T')[0];
                        }
                    }
                }
            },function(){
            }, function(result) {
                var errorHtml = GetAjaxRequestFaillHtml('companyList.GetList()', '');
                $("#companyList").html(errorHtml);
                loadingMsg.HideMsg();
            });
        },
        ReLoadData : function() {
            this.CurrentPageIndex = 1;
            this.GetList();
        },
        LoadNextData : function() {++this.CurrentPageIndex;
            this.GetList();
        }
    });

    w.ReturnGoodsNoticeList = function(params) {
        ReturnGoodsList.call(this, {});
        this.LType = "L054";
        this.QueryType = "QT1601";
        this.SellerID = "";
        for (var key in params) {
            this[key] = params[key];
        }
    }
    ReturnGoodsNoticeList.prototype = new ReturnGoodsList();
    $.extend(ReturnGoodsNoticeList.prototype, {
        GetList : function() {
            var CallData = {
                LType : this.LType,
                StrOptions : {
                    TenantID : this.TenantID,
                    QueryType : this.QueryType,
                    SellerID : this.SellerID,
                    PageIndex : this.CurrentPageIndex,
                    PageSize : this.PageSize,
                    StartTime : null,
                    EndTime : null
                }
            };
            this.ListCall(CallData, "QueryList", true, function(result) {
                var dataItems = result.Data.Items;
                for (var i in dataItems) {
                    if (dataItems[i].BizTime) {
                        dataItems[i].BizTime = dataItems[i].BizTime.split('T')[0];
                    }
                }
            });
        },
        ReLoadData : function() {
            this.CurrentPageIndex = 1;
            this.GetList();
        },
        LoadNextData : function() {++this.CurrentPageIndex;
            this.GetList();
        }
    });

    w.ReturnGoodsPartnerList = function(params) {
        ReturnGoodsList.call(this, {});
        this.LType = "L052";
        for (var key in params) {
            this[key] = params[key];
        }
    }
    ReturnGoodsPartnerList.prototype = new ReturnGoodsList();
    $.extend(ReturnGoodsPartnerList.prototype, {
        GetList : function() {
            var CallData = {
                LType : this.LType,
                StrOptions : {
                    TenantID : this.TenantID,
                    PageIndex : this.CurrentPageIndex,
                    PageSize : this.PageSize,
                    QueryValue : ""
                }
            };
            this.ListCall(CallData, "QueryList", true);
        },
        ReLoadData : function() {
            this.CurrentPageIndex = 1;
            this.GetList();
        },
        LoadNextData : function() {++this.CurrentPageIndex;
            this.GetList();
        }
    });

    w.ReturnGoodsReturnModeList = function(params) {
        ReturnGoodsList.call(this, {});
        this.LType = "L018";
        this.ctCode = "SR.TransMode";
        for (var key in params) {
            this[key] = params[key];
        }
    }
    ReturnGoodsReturnModeList.prototype = new ReturnGoodsList();
    $.extend(ReturnGoodsReturnModeList.prototype, {
        GetList : function() {
            var CallData = {
                LType : this.LType,
                StrOptions : {
                    ctcode : this.ctCode
                }
            };
            this.ListCall(CallData, "QueryList", true);
        },
        ReLoadData : function() {
            this.CurrentPageIndex = 1;
            this.GetList();
        },
        LoadNextData : function() {++this.CurrentPageIndex;
            this.GetList();
        }
    });

    w.ReturnGoodsLogisticsCompanyList = function(params) {
        ReturnGoodsList.call(this, {});
        this.LType = "L018";
        this.ctCode = "EBS.ExpressCompany";
        for (var key in params) {
            this[key] = params[key];
        }
    }
    ReturnGoodsLogisticsCompanyList.prototype = new ReturnGoodsList();
    $.extend(ReturnGoodsLogisticsCompanyList.prototype, {
        GetList : function() {
            var CallData = {
                LType : this.LType,
                StrOptions : {
                    ctcode : this.ctCode
                }
            };
            this.ListCall(CallData, "QueryList", true);
        },
        ReLoadData : function() {
            this.CurrentPageIndex = 1;
            this.GetList();
        },
        LoadNextData : function() {++this.CurrentPageIndex;
            this.GetList();
        }
    });

    w.ReturnGoodsCurrencyList = function(params) {
        ReturnGoodsList.call(this, {});
        this.LType = "L018";
        this.ctCode = "DATA.Currency";
        for (var key in params) {
            this[key] = params[key];
        }
    }
    ReturnGoodsCurrencyList.prototype = new ReturnGoodsList();
    $.extend(ReturnGoodsCurrencyList.prototype, {
        GetList : function() {
            var CallData = {
                LType : this.LType,
                StrOptions : {
                    ctcode : this.ctCode
                }
            };
            this.ListCall(CallData, "QueryList", true);
        },
        ReLoadData : function() {
            this.CurrentPageIndex = 1;
            this.GetList();
        },
        LoadNextData : function() {++this.CurrentPageIndex;
            this.GetList();
        }
    });
})(window)
